/*
 * Copyright 2008  Rivo Laks <rivolaks@hot.ee>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "asteroidgen.h"

#include <QApplication>

#include <iostream>
using namespace std;


int main(int argc, char *argv[])
{
    QCoreApplication app(argc, argv);

    QString outputfile;

    for (int i = 1; i < argc; i++) {
        QString arg(argv[i]);
        if (arg == "-o") {
            outputfile = argv[++i];
        }
    }

    if (outputfile.isEmpty()) {
        cerr << "Usage: " << argv[0] << " -o <output>" << endl;
        return 1;
    }

    AsteroidGen gen;
    if (!gen.generate()) {
        return 2;
    }
    if (!gen.saveModel(outputfile)) {
        return 3;
    }

    return 0;
}
