varying vec3 toLight;

uniform vec3 lightColor;
uniform float lightRadiusInverse;


void calculateLight(out vec3 direction, out vec3 color)
{
    float distSqr = dot(toLight, toLight);
    float att = clamp(1.0 - lightRadiusInverse * sqrt(distSqr), 0.0, 1.0);

    direction = toLight * inversesqrt(distSqr);
    color = lightColor * att;
}
