varying vec3 toLight;
varying float vertexdist;

uniform vec3 lightColor;


void calculateLight(out vec3 direction, out vec3 color)
{
    const vec3 A = vec3(0.0, 0.0, -1.0);
    float cone = radians(50.0);
    const float radius = 800.0;
    const float f = 50.0;

    vec3 L = normalize(toLight);
    direction = L;
    float LdotA = dot(-L, A);
    if(LdotA > cos(cone)) {
        float spot = pow(LdotA, f);
        float distByRadius = vertexdist / radius;
        float att = max(1.0 - (distByRadius * distByRadius), 0.0);

        color = lightColor * spot * att;
    } else {
        color = vec3(0.0);
    }
}
