/*
    Copyright 2008-2009  Rivo Laks <rivolaks@hot.ee>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef DISPLAYWIDGET_H
#define DISPLAYWIDGET_H

#include <kgllib/hdrglwidget.h>

class GameWorld;
class GLView;

namespace KGLLib
{
    class WidgetProxy;
}


class DisplayWidget : public KGLLib::HdrGLWidget
{
    Q_OBJECT
    public:
        DisplayWidget(QWidget* parent);
        ~DisplayWidget();

        virtual void initializeGL();
        virtual void resizeGL(int width, int height);
        virtual void render();
        virtual void renderScene();

        KGLLib::WidgetProxy* proxy();

        void appendView(GLView* view);
        void removeView(GLView* view);

    public slots:
        void showHdrConfig();

    signals:
        void signalRotateShip(int x, int y);

    protected:
        static QGLFormat createGLFormat();

        virtual void mouseMoveEvent(QMouseEvent* event);

    private:
        QString mDataDir;

        KGLLib::WidgetProxy* mProxy;

        QPoint mMousePos;

        QList<GLView*> mViews;
};

#endif // DISPLAYWIDGET_H
