/*
 * Copyright 2008  Rivo Laks <rivolaks@hot.ee>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "mainwindow.h"

#include <KDE/KAboutData>
#include <KDE/KApplication>
#include <KDE/KCmdLineArgs>
#include <KDE/KLocale>
#include <KDE/KStandardDirs>


int main(int argc, char *argv[])
{
    KAboutData about("astrododge", "", ki18n("AstroDodge"), "0.1.0");
    about.setLicense(KAboutData::License_GPL);
    about.addAuthor(ki18n("Rivo Laks"), ki18n("Author"), "rivolaks@hot.ee");
    KCmdLineArgs::init(argc, argv, &about);
    KCmdLineOptions options;
    KCmdLineArgs::addCmdLineOptions( options );

    KApplication app;

    KGlobal::dirs()->addResourceDir("appdata", "data");

    MainWindow* window = new MainWindow();

    window->show();
    return app.exec();
}
