/*
 * Copyright 2008-2009  Rivo Laks <rivolaks@hot.ee>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <KXmlGuiWindow>

class GameWorld;
class GameView;
class DisplayWidget;
class LoadingView;
class MenuView;

class KToggleAction;
class KAction;


/**
 * @author Rivo Laks <rivolaks@hot.ee>
 */
class MainWindow : public KXmlGuiWindow
{
    Q_OBJECT
    public:
        MainWindow();
        virtual ~MainWindow();

    public slots:
        void startNewGame();

        void dodgeLeft()   { dodge(-1,  0); }
        void dodgeRight()  { dodge( 1,  0); }
        void dodgeUp()     { dodge( 0,  1); }
        void dodgeDown()   { dodge( 0, -1); }
        void dodge(int x, int y);

        void fireCannon(bool fire);
        void setGamePaused(bool paused);

    protected:
        virtual void wheelEvent(QWheelEvent*);

        void setupActions();

    protected slots:
        void gameAboutToStart();

    private:
        DisplayWidget* mDisplay;
        GameWorld* mWorld;

        GameView* mView;
        LoadingView* mLoadingView;
        MenuView* mMenuView;

        // TODO: belongs to GameWorld
        bool mGameRunning;

        KToggleAction* mShowRenderInfoAction;
        KAction* mDetailIncreaseAction;
        KAction* mDetailDecreaseAction;
        KToggleAction* mShipLightAction;
};

#endif
