/*
    Copyright 2009  Rivo Laks <rivolaks@hot.ee>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef MENUVIEW_H
#define MENUVIEW_H

#include "glview.h"

namespace KGLLib
{
class WidgetProxy;
}
class QGraphicsProxyWidget;
class QFrame;


class MenuView : public GLView
{
    Q_OBJECT
    public:
        MenuView(KGLLib::GLWidget* parent);
        virtual ~MenuView();

        virtual void init();
        virtual void render();
        virtual void resize(int w, int h);

        KGLLib::WidgetProxy* proxy() const;

    public slots:
        void hide();

        void setMainMenuVisible(bool visible);

    signals:
        void startNewGame();
        void quitGame();

    protected:
        void loadStyleSheet();

        QGraphicsProxyWidget* createMenu(QFrame* menuContainer);

    private:
        QString mStyleSheet;

        QGraphicsProxyWidget* mMainMenuProxy;
};

#endif // MENUVIEW_H
