/*
    <one line to give the program's name and a brief idea of what it does.>
    Copyright (C) <year>  <name of author>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef PLANET_H
#define PLANET_H

#include <Eigen/Core>

namespace KGLLib
{
    class Mesh;
}


class Planet
{
    public:
        Planet(KGLLib::Mesh* model);

        void setPosition(const Eigen::Vector3f& pos);
        const Eigen::Vector3f& position() const  { return mPosition; }

        void setRadius(float r)  { mRadius = r; }
        float radius() const  { return mRadius; }

        virtual void render();

    private:
        KGLLib::Mesh* mModel;
        Eigen::Vector3f mPosition;
        float mRadius;
};

#endif // PLANET_H
