
#ifndef BACKGAMMON_FIBS_CONNECT
#define BACKGAMMON_FIBS_CONNECT


#include <QTcpSocket>


class BackgammonFibsConnect : public QObject
{
    Q_OBJECT
public:
    
    /**
    * Constructor
    */
    //BackgammonFibsConnect( QObject *parent, const QString& name, const QString& host, qint16 port );
    BackgammonFibsConnect( QObject *parent );

    /**
    * Destructor
    */
    virtual ~BackgammonFibsConnect();

    /**
    * Returns the file descriptor of the socket, or negative values
    * if the socket is closed.
    */
    int status();
    
    void makeConnect( const QString& host, qint16 port );
        
public slots:
        
    /**
     * Sends the string to the server
     */
    void sendData( const QString & );   
    
signals:
    /**
     * Emit e new line that came from the server
     */
    void newData( QString& );
    //void newData( QByteArray data );

    /**
     * Error signals that indicate a lost or a remotely closed
     * connection
     */
    void connectionDown();
    
    void connectionEstablished();
    
protected slots:

    /**
     * Get data from the server
     */
    void receiveData( );
    
    /**
     * Internally, connected to KSocket::writeEvent()
     */
    //void flushData( QTcpSocket *s );

    /**
     * Translate KSocket::closeEvent to connectionLost
     */
    //void transmitClose( QTcpSocket *s );
    
    void error( QAbstractSocket::SocketError );
    
    
    void hostFound();
    void connected();
    void connectionLost();

private:
    QTcpSocket* m_socket;
    QString rxBuffer;
    QString txBuffer;
};

#endif
