/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#ifndef CONFIG_H
#define CONFIG_H

#include <QString>

/**
implements persistend configuration. Config dialog is used to change values,
game rules , thinking time and more.

  @author Piotr Banasiak <piotrbanasiak@onet.pl>
*/

class Config
{
public:

    ~Config();

    int m_Level;///@todo remove it
    int m_WhiteLevel;
    int m_BlackLevel;
    QString m_WhiteLevelType;
    QString m_BlackLevelType;
    
    int m_boardSize;
    QString m_Rules;
    bool m_maxCaptureCompulsory;

    // allow this function to create one instance
    friend Config& Conf();
    void read();
    void write();

private:
    //prevent Constructor and copy constructor
    Config();
    Config(const Config&);
};

extern Config& Conf();
#endif
