/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#include "enginedetailswidget.h"
#include "config.h"

engineDetailsWidget::engineDetailsWidget(QWidget *parent,bool isWhite): QWidget(parent)
{
  ui.setupUi(this);
  m_isWhite=isWhite;
  if( m_isWhite)
     ui.lblWhatPlayer->setText( i18n("White player") );
  else
     ui.lblWhatPlayer->setText( i18n("Black player") );
     
  updateDialog();
}


engineDetailsWidget::~engineDetailsWidget()
{
}

void engineDetailsWidget::updateDialog()
{
  int level=0;
  QString levelType;
  if( m_isWhite)
  {
     level=Conf().m_WhiteLevel;
     levelType=Conf().m_WhiteLevelType;
  }
  else
  {
     level=Conf().m_BlackLevel;
     levelType=Conf().m_BlackLevelType;
  }
  
  ui.spinLevel->setValue( level );
  if( levelType== QString( "secPerMove") )
  {
     ui.radioSecPerMove->setChecked( true );
  }
  if( levelType== QString( "fixedDepth") )
  {
     ui.radioFixedDepth->setChecked( true );
  }
}

void engineDetailsWidget::updateConfig()
{
  if( m_isWhite)
  {
     Conf().m_WhiteLevel=ui.spinLevel->value();
     
     if(ui.radioSecPerMove->isChecked())
        Conf().m_WhiteLevelType=QString( "secPerMove");
     if(ui.radioFixedDepth->isChecked())
        Conf().m_WhiteLevelType=QString( "fixedDepth");
  }
  else
  {
     Conf().m_BlackLevel=ui.spinLevel->value();
     
     if(ui.radioSecPerMove->isChecked())
        Conf().m_BlackLevelType=QString( "secPerMove");
     if(ui.radioFixedDepth->isChecked())
        Conf().m_BlackLevelType=QString( "fixedDepth");
  }
  Conf().write();
}
#include "enginedetailswidget.moc"
