/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#include "engineplayer.h"
#include "board.h"
#include "game.h"
#include "config.h"
#include "boardt.h"
#include "engineintt.h"

enginePlayer::enginePlayer(QObject *parent,Game *pG):AbstractPlayer(parent)
{
  Q_ASSERT( pG );
  pGame=pG;
  level=1;
  m_timeManager.setReqTime(level);
}


enginePlayer::~enginePlayer()
{
}


void enginePlayer::yourMove( const LegalMove * /*lastMove*/ )
{
   Q_ASSERT( pGame );

   if( pGame->isGameOver()) return;
    
   bool found;
   LegalMove bestMove=pGame->getBookMove(found);
   
   if( found )
   {
     Q_ASSERT( bestMove.path.size() >=2 );
     bestMove.print();
   }
   

   //found=false;///@todo remove line
   if(!found)
   {
      Q_ASSERT( pGame->pAbstractEngine );
      AEngine *pE=pGame->pAbstractEngine;
      Board *pB=pGame->getCurrentBoard();
      
      if( levelType == QString ( "secPerMove" ))
         bestMove = pE->findBestMoveFixTime2( pB , level, m_timeManager );
      else if( levelType == QString ( "fixedDepth" ))
      {
         int depthLevel=level;
         int bestScore;
         bestMove = pE->findBestMoveFixDepth2( pB, depthLevel, bestScore );
      }
      else
         Q_ASSERT( false );
         
      Q_ASSERT( bestMove.path.size() >=2 );
   }

   emit moveFinished( bestMove );
   
}

void enginePlayer::setLevel(int L,const QString& Type)
{
    level=L;levelType=Type;
    m_timeManager.setReqTime(level);
}

#include "engineplayer.moc"

