/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#ifndef HUMANPLAYER_H
#define HUMANPLAYER_H

#include <QObject>
#include "abstractplayer.h"

/**
class represent human player

	@author Piotr Banasiak <piotrbanasiak@onet.pl>
*/
class BoardModel;

class humanPlayer :public AbstractPlayer
{
Q_OBJECT
public:
    humanPlayer( QObject *parent ,BoardModel *model );
    void enteredMove(LegalMove);
    void yourMove( const LegalMove *lastMove );
    void rejectGame();
    void acceptGame();

    ~humanPlayer();
    virtual enum playerType getType()const {return humanType;}
signals:
    void moveFinished(LegalMove);
private:
    BoardModel *pBoardModel;
};

#endif
