/***************************************************************************
 *   Copyright (C) 2005 by Piotr Banasiak <piotrbanasiak@onet.pl>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to                             *
 *   the Free Software Foundation, 51 Franklin Street, Fifth Floor,        *
 *   Boston, MA 02110-1301, USA.                                           *
 ***************************************************************************/
#ifndef MOVELISTMODEL_H
#define MOVELISTMODEL_H

#include <QAbstractTableModel>

/**
model for viewing moves (history) of the game

	@author Piotr Banasiak <piotrbanasiak@onet.pl>
*/

class Game;

class MoveListModel : public QAbstractTableModel
{
Q_OBJECT
public:
    explicit MoveListModel( Game *pGame );

    ~MoveListModel();
    void setGame( Game * );
    int rowCount ( const QModelIndex & parent = QModelIndex() ) const;
    int columnCount ( const QModelIndex & parent = QModelIndex() ) const;
    QVariant data ( const QModelIndex & index, int role = Qt::DisplayRole ) const;
    QVariant headerData(int section, Qt::Orientation orientation, int role) const;
private:
   Game * m_Game;
   int prevCurrent;
   int idx2row( int idx ) const; 
   int idx2col( int idx ) const;
   int rowCol2Idx( int row, int col ) const;
public slots:
    void onSizeChanged( int oldSize, int newSize );
    void onCurrentMoveChanged( int index );
};

#endif
