/*
 * Copyright 2008 Marijn Kruisselbrink <m.kruisselbrink@student.tue.nl>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef _MATH3D_H
#define _MATH3D_H

#include <Eigen/Core>
#include <Eigen/Geometry>

Eigen::Vector3f lerp(const Eigen::Vector3f &a, const Eigen::Vector3f &b, float u);
Eigen::Vector3f reflect(const Eigen::Vector3f &a, const Eigen::Vector3f &b);
void extractScaleRotation(const Eigen::Transform3f& t, Eigen::Vector3f& scale, Eigen::Vector3f& rot);
void extractScaleRotation(const Eigen::Transform3f& t, Eigen::Vector3f& scale, Eigen::Quaternionf& rot);
Eigen::Quaternionf extractRotation(const Eigen::Transform3f& t);
Eigen::Transform3f viewInverse(const Eigen::Transform3f& t);
Eigen::Matrix3f getNormMat(const Eigen::Transform3f& t);

inline static float sqr(float a)
{
    return a * a;
}

#endif // _MATH3D_H
