/*
 * Copyright 2008 Marijn Kruisselbrink <m.kruisselbrink@student.tue.nl>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "Textures.h"
#include <GL/glu.h>
#include <QImage>
#include <QGLContext>

bool loadTexture(const QString& filename, GLuint &texture, QGLContext* context)
{
    fprintf(stderr, "Loading surface %s\n", qPrintable(filename));
    QImage img = QImage(filename);
    if (img.isNull()) {
        fprintf(stderr, "Error loading image %s\n", qPrintable(filename));
        return false;
    }
    texture = context->bindTexture(img);
    fprintf(stderr, "Texture loaded: %lu\n", (unsigned long) texture);
    return true;
}
