/*
    gamefustatusbar.h - Gamefu Status Bar

    Copyright (c) 2006 by Michaël Larouche       <larouche@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/
#ifndef GAMEFUSTATUSBAR_H
#define GAMEFUSTATUSBAR_H

#include <statusBarBase.h>

/**
 * @brief Gamefu status bar
 * Inherit fancy KDE::StatusBar imported from amaroK.
 * Help to display static elements like number of items in collection.
 *
 * @author Michaël Larouche <larouche@kde.org>
*/
class GamefuStatusBar : public KDE::StatusBar
{
	Q_OBJECT
public:
	/**
	 * @brief Create a new GamefuStatusBar
 	 */
	GamefuStatusBar(QWidget *parent = 0);
	/**
	 * d-tor
	 */
	~GamefuStatusBar();

public slots:
	/**
	 * @brief Update collection total label.
	 * @param totalRoms Number to display.
	 */
	void updateCollectionTotal(int totalRoms);

private:
	class Private;
	Private *d;
};

#endif
