#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kdemacros.h>
#include <qfile.h>

#include "ndscreator.h"
#include "ndsfile.h"

extern "C" {
	KDE_EXPORT ThumbCreator *new_creator() {
		return new NDSCreator;
	}
}

bool NDSCreator::create(const QString &path, int width, int height, QImage &img) {
	NDSFile ndsFile(path);
	if (!ndsFile.isValid() || ndsFile.isGstDump()) return false;
	return ndsFile.loadIcon(img);
}

ThumbCreator::Flags NDSCreator::flags() const {
    return static_cast<Flags>(None);
}
