/*
    system.cpp - Base class for system plugin.

    Copyright (c) 2005      by Michaël Larouche       <larouche@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/
#include "system.h"

// Qt includes
#include <qstringlist.h>

// KDE include
#include <kplugininfo.h>


namespace Gamefu 
{

class System::Private
{
public:
	QStringList systemMimeTypes;
};

System::System(KInstance *instance, QObject *parent, const char *name)
 : Gamefu::Plugin(instance, parent, name), d(new Private())
{
}

System::~System()
{
	delete d;
}

QStringList System::getRegistredSystemMimeTypes() const
{
	return d->systemMimeTypes;
}

void System::registerSystemMimeType(const QString &mimeType)
{
	d->systemMimeTypes.append(mimeType);
}

QString System::systemName() const
{
	return pluginInfo()->property( QString::fromUtf8("X-Gamefu-System-DisplayName") ).toString();
}

}

#include "system.moc"
