/*
    imagefillerplugin.cpp - Image Filler plugin.

    Copyright (c) 2006      by Michaël Larouche       <larouche@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/
#include "imagefillerplugin.h"

// Qt includes
#include <qfile.h>

// KDE includes
#include <kgenericfactory.h>
#include <kdebug.h>
#include <kaction.h>
#include <kdirselectdialog.h>
#include <kxmlguiclient.h>
#include <kiconloader.h>
#include <klocale.h>

// Gamefu includes
#include <collectionaccess.h>
#include <notifymanager.h>
#include <rommetainformation.h>

#include "imagefillerdialog.h"

typedef KGenericFactory<ImageFillerPlugin> imageFillerFactory;
K_EXPORT_COMPONENT_FACTORY(gamefu_imagefiller, imageFillerFactory( "gamefu_imagefiller" ))

ImageFillerPlugin::ImageFillerPlugin(QObject *parent, const char *name, const QStringList &/*args*/)
 : Gamefu::Plugin( imageFillerFactory::instance(), parent, name)
{
	// Create actions
	new KAction(i18n("Fill images in database..."), SmallIcon("image"), 0, this, SLOT(collectionImageLookup()), actionCollection(), "collectionImageLookup");

	setXMLFile("imagefillerui.rc");
}

ImageFillerPlugin::~ImageFillerPlugin()
{
}

void ImageFillerPlugin::collectionImageLookup()
{
	ImageFillerDialog *fillerDialog = new ImageFillerDialog;
	fillerDialog->show();
}

#include "imagefillerplugin.moc"
