/*
    genesisrommetadata.cpp - Extract metadata(information) from Sega Genesis/Megadrive ROM file.

    Copyright (c) 2006      by Michaël Larouche       <larouche@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/
#include "genesisrommetadata.h"

#include <kmdcodec.h>

GenesisRomMetaData::GenesisRomMetaData()
 : Gamefu::DefaultRomMetaData()
{
}


GenesisRomMetaData::~GenesisRomMetaData()
{
}


Gamefu::RomMetaInformation GenesisRomMetaData::extractMetaInformation(KFileItem* item)
{
    return DefaultRomMetaData::extractMetaInformation(item);
}

Gamefu::RomMetaInformation GenesisRomMetaData::extractMetaInformation(QIODevice* device)
{
    Gamefu::RomMetaInformation romMetaData;
	QString md5Hash;

	// Generate the MD5 Hash
	KMD5 context(0L);
	context.update(*device);
	md5Hash = context.hexDigest();
	
	romMetaData.setMd5Hash(md5Hash);

	return romMetaData;
}

