/*
    genesisrommetadata.h - Extract metadata(information) from Sega Genesis/Megadrive ROM file.

    Copyright (c) 2006      by Michaël Larouche       <larouche@kde.org>

    *************************************************************************
    *                                                                       *
    * This program is free software; you can redistribute it and/or modify  *
    * it under the terms of the GNU General Public License as published by  *
    * the Free Software Foundation; either version 2 of the License, or     *
    * (at your option) any later version.                                   *
    *                                                                       *
    *************************************************************************
*/
#ifndef GENESISROMMETADATA_H
#define GENESISROMMETADATA_H

#include <defaultrommetadata.h>

/**
 * Extract metadata(information) from Sega Genesis/Megadrive ROM file.
 * 
 * @author Michaël Larouche <larouche@kde.org>
*/
class GenesisRomMetaData : public Gamefu::DefaultRomMetaData
{
public:
	GenesisRomMetaData();
	
	~GenesisRomMetaData();
	
	virtual Gamefu::RomMetaInformation extractMetaInformation(KFileItem* item);
	virtual Gamefu::RomMetaInformation extractMetaInformation(QIODevice *device);

};

#endif
