

#ifndef _HIQ_H_
#define _HIQ_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kapplication.h>
#include <kmainwindow.h>
#include <qaction.h>
#include <kconfig.h>

#include "hiqview.h"
#include <qdragobject.h>
#include <qpainter.h>
#include <qpaintdevicemetrics.h>
#include <qpushbutton.h>

#include <kglobal.h>
#include <klocale.h>
#include <kiconloader.h>
#include <kdeversion.h>
#include <kstatusbar.h>
#include <kaccel.h>
#include <kio/netaccess.h>
#include <kfiledialog.h>
#include <kconfig.h>
#include <kurl.h>
#include <kurldrag.h>
#include <kurlrequesterdlg.h>

#include <kstdaccel.h>
#include <qpopupmenu.h>
#include <kmenubar.h>
#include <kaction.h>
#include <kstdaction.h>
#include "peg.h"
#include <kmessagebox.h>
#include <qcheckbox.h>
#include <qradiobutton.h>

class QPrinter;
class KURL;

/**
 * This class serves as the main window for HiQ.  It handles the
 * menus, toolbars, and status bars.
 *
 * @short Main window class
 * @author Samuel Hoffstaetter <sfh23@cornell.edu>
 * @version 0.1
 */
class HiQ : public KMainWindow {
    Q_OBJECT
public:
    /**
     * Default Constructor
     */
    HiQ();

    /**
     * Default Destructor
     */
    virtual ~HiQ();

    /**
     * Use this method to load whatever file/URL you have
     */
    void load(const KURL& url);
    
protected:
    /**
     * This function is called when it is time for the app to save its
     * properties for session management purposes.
     */
    void saveProperties(KConfig *);

    /**
     * This function is called when this app is restored.  The KConfig
     * object points to the session management config file that was saved
     * with @ref saveProperties
     */
    void readProperties(KConfig *);

    void updateProperties();

private slots:
    void fileNew();
    void fileOpen();
    void fileSave();
    void fileSaveAs();
    void filePrint();
    void optionsPreferences();

    void changeStatusbar(const QString& text);
    void changeCaption(const QString& text);
    
    void setEditableIcon(bool isEditable);

private:
    void setupAccel();
    void setupActions();

private:
    HiQView *m_view;
    QPrinter   *m_printer;

private:
    QString m_style;
    bool animateAll;
    KToggleAction *editable;
    int advancePeriod;
    int advancePeriodFast;
};

#endif // _HIQ_H_

