
#include "colors.inc"
#include "textures.inc"
#include "theme.inc"

#declare rnd = seed(0);

camera {
    location <0, 21-((cos(2*pi*(clock))-1)/2)*18, 0>
                look_at 0
                        up <0, 0, 1>
                        right <1, 0, 0>
}

// general light definition
light_source {
    <100000000, 220000000, 70000000>      // position of the light source
            color rgb .6     // color of the light
}
// general light definition
light_source {
    <0, 900000000, 0>      // position of the light source
            rgb 1
                    fade_distance 80000000
                    fade_power 1.0
}

#declare peg_cut = sphere {
    0, 1
}

#declare board = merge{
    difference {

        box {
            <10.5, 0, 10.5>, <-10.5, -2, -10.5> 
        }
#declare i = 0;
#while (i < 7)
#declare j = 0;
#while (j < 7) 
#if ((i >=2 & i <= 4) |
                    (j >= 2 & j <= 4))
//#if (i = 3 & j = 3)        
        object {
    peg_cut
    translate <(i-3)*3, 0, (j-3)*3>
                }
#end
#declare j = j+1;
#end
#declare i = i+1;
#end
    texture{boardTexture}
    }

#declare i = 0;
#while (i < 7)
#declare j = 0;
#while (j < 7) 
#if ((i >=2 & i <= 4) |
                    (j >= 2 & j <= 4))
#if (!(i = 3 & j = 3))
object {
    peg((floor(rand(rnd)*500))/500+clock/3-1/3)
            translate <-(j-3)*3, 7*(1-clock), -(i-3)*3>
            no_shadow
                    no_reflection
}
#end
#end
#declare j = j+1;
#end
#declare i = i+1;
#end
}
object {board
    rotate x*(-clock*180+180)
}

/* Star field */
/*sphere {
<0,0,0>, 1
hollow
        pigment {
    image_map {
        png "starmap.png"
                map_type 1 // Spherical
                once
    }
        }
        finish {
            ambient 2 // Inverse of earlier global ambient level
                    diffuse 0
        }
        scale 1000000000 // Depends on model units 
}*/

