

#ifndef _HIQPREF_H_
#define _HIQPREF_H_

#include <kdialogbase.h>
#include <qframe.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <qslider.h>

#define minUpdateSpeed 100
#define maxUpdateSpeed 5

class HiQGenPref;
class HiQThemePref;

class HiQPreferences : public KDialogBase {
    Q_OBJECT
public:
    HiQPreferences(bool anim, int animUpdateDelay, int noAnimUpdateDelay, QString style);

public:
    HiQGenPref *m_prefGeneral;
    HiQThemePref *m_prefTheme;
};

class HiQGenPref : public QWidget {
    Q_OBJECT
public:
    HiQGenPref(QWidget *parent, bool animate, int animUpdateDelay, int noAnimUpdateDelay);
public:
    QRadioButton* anim;
    QRadioButton* noAnim;
    QSlider* animSlider;
    QSlider* noAnimSlider;
};


class HiQThemePref : public QWidget {
    Q_OBJECT
public:
    HiQThemePref(QWidget *parent, QString style);
public:
    QRadioButton* marble;
    QRadioButton* wood;
    QRadioButton* metal;
};

#endif // _HIQPREF_H_
