/*
    Copyright 2009  Stanislas Marquis <smarquis@chaosorigin.com>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "raman.h"

int rasi_dif( int r1, int r2 )
{
    r1 = rasi_norm( r1 );
    r2 = rasi_norm( r2 );
    if ( r1 == r2 )
        return 0;
    else if ( r1 < r2 )
        return 12 - ( r2 - r1 );
    return r1 - r2;
}

int rasi_dif2( int r1, int r2 )
{
    const int i = rasi_dif( r1, r2 );
    return ( i > 6 ) ? ( -6 + ( i - 6 )) : i;
}

int long2nakshatra( double sputha, int* ret )
{
    sputha = swe_degnorm( sputha );
    ret[0] = (int) ( sputha / ( 40 / 3.0 ) ); /* nakshatra [0:26] */
    ret[1] = (int) ( ( sputha - ( ret[0] * ( 40 / 3.0 ) ) ) / ( 10 / 3.0 ) ); /* pada [0:3] */
    return ret[0];
}

double long2varga( double sputha, int varga )
{
    sputha = swe_degnorm( sputha );
    const int div = 30.0 / varga;
    const int n = (int) sputha / div;
    const int n2 = ( n / 12 ) * div;
    return swe_degnorm( ( n * 30.0 ) + n2 + fmod( sputha, div ) );
}
