/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "blender-blendthread.h"
#include "blender-manager.h"

Kolf::BlendThread::BlendThread(BlenderManager* manager, QObject* parent)
	: QThread(parent)
	, m_manager(manager)
{
	connect(this, SIGNAL(processFinished()), m_manager, SIGNAL(blendingFinished()));
}

Kolf::BlendThread::~BlendThread()
{
	m_waitCondition.wakeOne();
	terminate();
}

void Kolf::BlendThread::process()
{
	if(!isRunning())
		start(LowPriority);
	else
		m_waitCondition.wakeOne();
}

void Kolf::BlendThread::run()
{
	forever
	{
		m_manager->processBlending();
		emit processFinished(); 
		m_waitCondition.wait(&m_mutex);
	}
}

#include "blender-blendthread.moc"
