/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_BLENDER_ITEMEDITOR_H
#define KOLF_BLENDER_ITEMEDITOR_H
#include <QWidget>
#include <QSpinBox>

class QPushButton;

namespace Kolf
{
	class BlenderItemEditor : public QWidget
	{
		Q_OBJECT
		public:
			BlenderItemEditor(QWidget* parent = 0);
			void setValue(int min, int opt, int max);
			QSpinBox* minBox() {return m_min;}
			QSpinBox* optBox() {return m_opt;}
			QSpinBox* maxBox() {return m_max;}
	
		private Q_SLOTS:
			void minValueChanged(int value);
			void optValueChanged(int value);
			void maxValueChanged(int value);
		Q_SIGNALS:
			void closed();
		protected:
			virtual void closeEvent(QCloseEvent* event);
		private:
			QSpinBox* m_min;
			QSpinBox* m_opt;
			QSpinBox* m_max;
			QPushButton* m_button;
	
	};
}
#endif // KOLF_BLENDER_ITEMEDITOR_H
