/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *   Copyright 2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_BLENDER_MODEL_H
#define KOLF_BLENDER_MODEL_H

#include <QAbstractListModel>
class KUrl;

namespace Kolf
{
	class BlenderTexture;
	
	class TextureModel : public QAbstractListModel
	{
		Q_OBJECT
		
		public:
			TextureModel(QObject* parent = 0);
			virtual ~TextureModel();

			int rowCount(const QModelIndex& parent = QModelIndex()) const;
			QVariant data(const QModelIndex& index, int role) const;
			Qt::ItemFlags flags(const QModelIndex& index) const;
			bool setData(const QModelIndex& index, const QVariant& value, int role = Qt::EditRole);

			QList<Kolf::BlenderTexture*> textures() const;
			void addTexture(const QModelIndex& poolIndex);
			void removeTexture(int index);
		Q_SIGNALS:
			///This signal is used to avoid unneeded reblending.
			void texturesModified();
		private:
			QList<Kolf::BlenderTexture*> m_textures;
			QList<QPixmap> m_thumbnails;
	};
}
#endif // KOLF_BLENDER_MODEL_H
