/***************************************************************************
 *   Copyright 2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "blender-stacker.h"
#include "blender-stacker-texturebar.h"

#include <QGraphicsItem>

Kolf::BlenderStacker::BlenderStacker()
	: m_scene(new QGraphicsScene)
	, m_textureBar(new Kolf::BsTextureBar)
{
	setScene(m_scene);
	m_scene->addItem(m_textureBar);
	//make the QGraphicsView itself invisible (only the content items are important)
	setFrameStyle(QFrame::NoFrame);
	setStyleSheet("background:transparent");
	//debug content
	m_textureBar->addKey("default-rock");
	m_textureBar->addKey("default-grass");
	m_textureBar->addKey("default-water");
}

Kolf::BlenderStacker::~BlenderStacker()
{
	delete m_scene;
}

void Kolf::BlenderStacker::resizeEvent(QResizeEvent* event)
{
	setSceneRect(QRectF(0, 0, width(), height()));
	fitInView(sceneRect());
	//debug layout
	m_textureBar->setHeight(height() - 10);
	m_textureBar->setPos(30, 5);
}
