/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "hmcreator-ellipseselectbutton.h"

#include <QPainter>
#include <KIcon>
#include <KLocalizedString>

Kolf::EllipseSelectButton::EllipseSelectButton(QWidget* parent)
	: ToolButton(parent)
{
	setIcon(KIcon(""));
	setText(i18n("Select ellipsoidal area"));
	setToolTip(i18n("Restrict further operations to a certain ellipsoidal area of the heightmap."));
	setObjectName("EllipseSelectButton");
}

Kolf::EllipseSelectButton::~EllipseSelectButton()
{
}

void Kolf::EllipseSelectButton::handleMousePressed(DrawingBoard* board, QMouseEvent* event)
{
	Q_UNUSED(event)
	//clear selection
	board->setSelection(QPainterPath());
}

void Kolf::EllipseSelectButton::handleMouseMoved(DrawingBoard* board, QMouseEvent* event)
{
	//set new selection
	QPainterPath region;
	region.addEllipse(QRectF(board->lastPoint(), event->posF()));
	board->setSelection(region);
}

void Kolf::EllipseSelectButton::handleMouseReleased(DrawingBoard* board, QMouseEvent* event)
{
	QPainterPath region;
	region.addEllipse(QRectF(board->lastPoint(), event->posF()));
	board->setSelection(region);
}
