/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "hmcreator-eraserconfwidget.h"
#include "hmcreator-eraserbutton.h"
#include <QGroupBox>
#include <QLabel>
#include <QPushButton>
#include <QSpinBox>
#include <QVBoxLayout>

Kolf::EraserConfWidget::EraserConfWidget(ToolButton* button, QWidget* parent)
	: QWidget(parent)
	, m_button(button)
{
	setupUI();
	connect(this, SIGNAL(eraserWidthChanged(int)), m_button, SLOT(setEraserWidth(int)));
}

void Kolf::EraserConfWidget::setupUI()
{	
	QGroupBox* groupBox = new QGroupBox(this);
	QVBoxLayout* layout = new QVBoxLayout;
	QLabel* title = new QLabel("Eraser Width");
	layout->addWidget(title);
	QSpinBox* spinbox = new QSpinBox;
	connect(spinbox, SIGNAL(valueChanged(int)), this, SIGNAL(eraserWidthChanged(int)));
	spinbox->setRange(1, 100);
	spinbox->setValue(10);
	layout->addWidget(spinbox);
	QPushButton* okButton = new QPushButton(QString("OK"));
	layout->addWidget(okButton);
	groupBox->setLayout(layout);
}

#include "hmcreator-eraserconfwidget.moc"
