/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "hmcreator-toolbutton.h"

Kolf::ToolButton::ToolButton(QWidget* parent)
	: QToolButton(parent)
{
	setToolButtonStyle(Qt::ToolButtonTextBesideIcon);
	setCheckable(true);
	setChecked(false);
	setAutoRaise(true);
	setSizePolicy(QSizePolicy::Expanding, QSizePolicy::Fixed);
}

Kolf::ToolButton::~ToolButton()
{

}

QSize Kolf::ToolButton::sizeHint() const
{
	return QSize(22, 22);
}

void Kolf::ToolButton::work(DrawingBoard* board, QMouseEvent* event)
{
	switch(event->type())
	{
		case QEvent::MouseButtonPress:
			handleMousePressed(board, event);
			break;
		case QEvent::MouseMove:
			handleMouseMoved(board, event);
			break;
		case QEvent::MouseButtonRelease:
			handleMouseReleased(board, event);	
			break;
		default:
			;
	}
}

void Kolf::ToolButton::onSelected(DrawingBoard* board)
{
	Q_UNUSED(board);
}

void Kolf::ToolButton::handleMousePressed(DrawingBoard* board, QMouseEvent* event)
{
	Q_UNUSED(board);
	Q_UNUSED(event);
}

void Kolf::ToolButton::handleMouseMoved(DrawingBoard* board, QMouseEvent* event)
{
	Q_UNUSED(board);
	Q_UNUSED(event);
}

void Kolf::ToolButton::handleMouseReleased(DrawingBoard* board, QMouseEvent* event)
{
	Q_UNUSED(board);
	Q_UNUSED(event);
}
