/***************************************************************************
 *   Copyright 2009 Zeng Huan <zh.issac@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_OBJECT_ENVIRONMENT_H
#define KOLF_OBJECT_ENVIRONMENT_H

#include "object.h"

namespace Kolf
{

	class TerrainGeometry;

	class EnvironmentObject : public Kolf::Object
	{
		Q_OBJECT
		Q_PROPERTY(QString PathToHeightmap READ pathToHeightmap WRITE setPathToHeightmap)
		Q_PROPERTY(QString PathToTexture READ pathToTexture WRITE setPathToTexture)
		Q_PROPERTY(QImage Heightmap READ heightmap WRITE setHeightmap)

		public:
			EnvironmentObject(dWorldID worldID, dSpaceID spaceID);
			virtual ~EnvironmentObject();
			QString pathToHeightmap() const { return m_pathToHeightmap; }
			void setPathToHeightmap(const QString& pathToHeightmap);
			QString pathToTexture() const { return m_pathToTexture; }
			void setPathToTexture(const QString& pathToTexture);

			QImage heightmap() const;
			void setHeightmap(const QImage& heightmap);

			const Kolf::TerrainGeometry* terrainGeometry() const;
		protected:
			virtual Overlay* createOverlay();
		private:
			Kolf::TerrainGeometry* m_geometry;
			QGraphicsPixmapItem* m_item;
			QString m_pathToHeightmap;
			QString m_pathToTexture;
	};
}

#endif // KOLF_OBJECT_ENVIRONMENT_H
