/***************************************************************************
 *   Copyright 2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "component-basicviews.h"
#include "view2d.h"
#include "view3d.h"

#include <KLocalizedString>

//BEGIN Kolf::View2DComponent

Kolf::View2DComponent::View2DComponent()
	: Kolf::GameUIPageWidget(i18n("&2D view"))
	, m_view(new Kolf::View2D)
{
	setContent(m_view); //m_view is deleted automatically when this page widget is destroyed!
}

void Kolf::View2DComponent::currentSceneChanged(Kolf::Scene* oldScene, Kolf::Scene* newScene)
{
	Q_UNUSED(oldScene)
	m_view->setScene(newScene);
}

//END Kolf::View2DComponent

//BEGIN Kolf::View3DComponent

Kolf::View3DComponent::View3DComponent()
	: Kolf::GameUIPageWidget(i18n("&3D view"))
	, m_view(Kolf::View3D::create())
{
	setContent(m_view); //m_view is deleted automatically when this page widget is destroyed!
}

void Kolf::View3DComponent::currentSceneChanged(Kolf::Scene* oldScene, Kolf::Scene* newScene)
{
	Q_UNUSED(oldScene)
	m_view->setScene(newScene);
}

//END Kolf::View3DComponent
