/***************************************************************************
 *   Copyright 2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_COMPONENT_SCORECARD_H
#define KOLF_COMPONENT_SCORECARD_H

#include "gameui-dockwidget.h"

class QTableView;

namespace Kolf
{
	class Game;
	class ScoreModel;
	class TransposeProxyModel;

	class ScoreCardComponent : public Kolf::GameUIDockWidget
	{
		Q_OBJECT
		public:
			ScoreCardComponent();
			virtual ~ScoreCardComponent();

			void setGame(Kolf::Game* game);
		private Q_SLOTS:
			void slotDockLocationChanged(Qt::DockWidgetArea area);
		private:
			QTableView* m_view;
			Kolf::TransposeProxyModel* m_tpModel;
			Kolf::ScoreModel* m_model;
	};
}

#endif // KOLF_COMPONENT_SCORECARD_H
