/***************************************************************************
 *   Copyright 2008-2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_PLAYER_DUMMY_H
#define KOLF_PLAYER_DUMMY_H

#include "player.h"

namespace Kolf
{
	/**
	 * \class DummyPlayer
	 * \since 2.0
	 *
	 * This class represents a player that cannot play (i.e. does nothing when control is passed to him). Such a player can still be used for score management.
	 */
	class DummyPlayer : public Kolf::Player
	{
		Q_OBJECT
		public:
			DummyPlayer(const QString& name, unsigned int holeCount);
			virtual ~DummyPlayer();
		public Q_SLOTS:
			virtual void giveControl();
			virtual void takeControl();
	};
}

#endif // KOLF_PLAYER_DUMMY_H
