/***************************************************************************
 *   Copyright 2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_DIALOG_NEWGAME_PLAYERLIST_H
#define KOLF_DIALOG_NEWGAME_PLAYERLIST_H

#include <QList>
class QGridLayout;
class QPushButton;
class QSpacerItem;
#include <QWidget>

namespace Kolf
{
	class NormalGame;
	class NewGamePlayerWidget;

	class NewGamePlayerList : public QWidget
	{
		Q_OBJECT
		public:
			NewGamePlayerList();
			void writePlayers(Kolf::NormalGame* game);
		public Q_SLOTS:
			void addPlayer();
		private Q_SLOTS:
			void removePlayer();
		private:
			QList<Kolf::NewGamePlayerWidget*> m_playerWidgets;
			QList<QPushButton*> m_removeButtons;
			QGridLayout* m_layout;
			QSpacerItem* m_bottomSpacer; //needs to be stored as it is moved around in the layout when players are added or removed
	};
}

#endif // KOLF_DIALOG_NEWGAME_PLAYERLIST_H
