/***************************************************************************
 *   Copyright 2009 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#include "newgame-playerwidget.h"

#include <QHBoxLayout>
#include <KColorButton>
#include <KLineEdit>

Kolf::NewGamePlayerWidget::NewGamePlayerWidget()
	: m_nameWidget(new KLineEdit(this))
	, m_colorWidget(new KColorButton(this))
{
	QHBoxLayout* layout = new QHBoxLayout;
	layout->addWidget(m_nameWidget);
	layout->addWidget(m_colorWidget);
	setLayout(layout);
}

QString Kolf::NewGamePlayerWidget::name() const
{
	return m_nameWidget->text();
}

QColor Kolf::NewGamePlayerWidget::color() const
{
	return m_colorWidget->color();
}

void Kolf::NewGamePlayerWidget::setDefaultColor(const QColor& color)
{
	m_colorWidget->setColor(color);
	m_colorWidget->setDefaultColor(color);
}

void Kolf::NewGamePlayerWidget::setDefaultName(const QString& name)
{
	m_nameWidget->setText(name);
}
