/***************************************************************************
 *   Copyright 2008, 2009, 2010 Stefan Majewsky <majewsky@gmx.net>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef KOLF_OBJECT_WALL_H
#define KOLF_OBJECT_WALL_H

#include "object.h"

namespace Kolf
{
	class WallShape;

	///Note: The reference point for this object is its center. The extent is the distance from one of the wall's corners to its center.
	class WallObject : public Kolf::Object
	{
		Q_OBJECT
		Q_PROPERTY(QPointF Extent READ extent WRITE setExtent)
		public:
			WallObject(b2World* world);

			QPointF extent() const;
			void setExtent(const QPointF& extent);
			void setExtent(const QPointF& point1, const QPointF& point2);
		protected:
			virtual Kolf::Overlay* createOverlay();
		private:
			Kolf::WallShape* m_shape;
			QGraphicsLineItem* m_item;
	};
}

#endif // KOLF_OBJECT_WALL_H
