#ifndef _KGSELECTIONINTERFACE_H_
#define _KGSELECTIONINTERFACE_H_

#include <QObject>
#include <QList>
#include <KIcon>
#include "KGContainer.h"
#include "KGObject.h"
#include "KGEraser.h"

struct KGLayerData
{
    KGObject *selectedObject;
    int layerID;
};

class KGSelectionInterface: public QObject
{
Q_OBJECT
    KGContainer *m_container;
    QList<KGLayerData> m_layerDataList;
    KGObject *m_selectedObject;
    KGEraser *eraserObject;
    int m_workingLayerID;
    bool m_eraserState;
public:
    
    KGSelectionInterface();
    virtual ~KGSelectionInterface();

    void setSelectedObject(KGObject *object);
    KGObject *selectedObject();
    KGObject *selectedObjectFromLayer(int layerID);
    static KGSelectionInterface *instance();
    KGContainer *container(void);
    
    void setEraserMode(bool state);
    bool eraserMode(void);
    void setlayerID(int newLayerID);
    bool layerID(void);
protected:
    void updateLayerData(KGObject *selectedObject, int layerID);
signals:
    void currentObjectChanged(KGObject *object, int layerID);
    void eraserModeChanged(bool state);
    void layerIDChanged(int newLayerID);
};

#endif
