#include "KGTile.h"

#include <KDebug>
KGTile::KGTile(QString argPicLocation, QString tileName, QGraphicsItem *parent) :
KGObject(parent)
{
    picLocation = argPicLocation;
    QPixmap getImage(picLocation);
    //set the tiles name
    varName = tileName;

    //set the image
    image = getImage;
}
KGTile::KGTile(QPixmap &getImage, QString tileName, QGraphicsItem *parent) :
KGObject(parent)
{
    //set the tiles name
    varName = tileName;

    //set the image
    image = getImage;
}
KGTile::KGTile(KGTile *tileObject, QString tileName, QGraphicsItem *parent) :
KGObject(parent)
{
    //set the tiles name
    varName = tileName;

    //set the image
    picLocation = tileObject->getPicLocation();
    image = tileObject->getImage();
}
KGTile::KGTile()
{
    
}
KGTile::~KGTile()
{

}
void KGTile::editObject(void)
{
    
}
KGObject *KGTile::clone()
{ 
    KGTile *tile = new KGTile(picLocation, varName);
    tile->setReference(reference());
    return tile;
}
QDomElement KGTile::saveObject(QDomDocument &doc)
{
    //create tile element
    QDomElement objectElement = doc.createElement("tile");
    objectElement.setAttribute("name",varName);

    //create image element
    QDomElement imageElement = doc.createElement("image");
    imageElement.setAttribute("location",picLocation);
    objectElement.appendChild(imageElement);

    return objectElement;
}
void KGTile::loadObject(QDomElement &objectElement )
{
    //get name
    varName = objectElement.attribute("name");

    //get image element
    QDomElement imageElement = objectElement.firstChildElement("image");

    //get image url
    picLocation = KGlobal::dirs()->findResource("data", "kollagame/images/" + imageElement.attribute("location"));
    
    //load image
    QPixmap loadImage(picLocation);
    image = loadImage;
}
QRectF KGTile::boundingRect() const
{
    return QRectF(0,0,TILE_SIZE,TILE_SIZE);
}
QString KGTile::getPicLocation(void)
{
    return picLocation;
}
QPixmap &KGTile::getImage(void)
{
    return image;
}
void KGTile::setImage(QPixmap &argImage)
{
    image = argImage;
}
void KGTile::paint(QPainter *painter, const QStyleOptionGraphicsItem *, QWidget *)
{
    painter->drawPixmap(0,0,image);
}
