/***************************************************************************
 *   Copyright (C) 2007 by Michal Sciubidlo <michal.sciubidlo@gmail.com>   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef DICTIONARY_H 
#define DICTIONARY_H 

#include <QString>
#include <QMap>

#include <kombination_export.h>

namespace Sonnet
{
	class Speller;
}

struct letter
{	
	quint32 nextAddress;
	qint8 letter;
	bool isWordEnd; 
	bool isSequenceEnd;
};

class KOMBINATION_EXPORT dictionary
{     
	

	public:
		dictionary(const QString &language);
		~dictionary();
		
		static QStringList languages();

		bool isCorrect(const QString &word);
		QString& language();
		QString decodeLetter(qint8 code);
		qint8 letterCode(const QString &letter);
		letter* getInnerTable();
	private:
		QString m_language;
		letter *letters;
		bool isUsingAspell;
		//KSpell2::Loader::Ptr m_broker;
		Sonnet::Speller *kSpellDict;
		QMap<QString, qint8> coddingMap;
		QMap<qint8, QString> decoddingMap;
};
#endif
