/***************************************************************************
 *   Copyright (C) 2006 by Pino Toscano <toscano.pino@tiscali.it>          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include "eventslogwidget.h"

#include <QTime>
#include <QVBoxLayout>

#include <kglobal.h>
#include <klocale.h>
#include <ktextedit.h>


eventsLogWidget::eventsLogWidget(QWidget *parent) : QWidget(parent)
{
	QVBoxLayout *lay = new QVBoxLayout(this);
	lay->setMargin(0);
	m_edit = new KTextEdit(this);
	lay->addWidget(m_edit);
	m_edit->setReadOnly(true);
}

eventsLogWidget::~eventsLogWidget()
{
}

void eventsLogWidget::addMessage(const QString &message)
{
	addMessageWithTime(message);
}

void eventsLogWidget::addErrorMessage(const QString &message)
{
	addMessageWithTime(i18nc("%1 represents the error message", "<font color=\"red\"><b>Error:</b></font> %1",message));
}

void eventsLogWidget::addMessageWithTime(const QString &text)
{
	QString timestring = KGlobal::locale()->formatTime(QTime::currentTime(), true);
	m_edit->append(QString("<font color=\"#709070\">[%1]</font> %2").arg(timestring, text));
}

#include "eventslogwidget.moc"
