/***************************************************************************
 *   Copyright (C) 2005 by Albert Astals Cid <tsdgeos@terra.es>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef LOG_H
#define LOG_H 

#include <QAbstractTableModel>
#include <QList>
#include <QPair>
#include <QStringList>

class logEntry
{
	public:
		logEntry(const QStringList &words, int score);

		QString representation() const;
	
	private:
		QStringList m_words;
		int m_score;
};

class log : public QAbstractTableModel
{
	public:
		log();
		~log();

		void start(const QStringList &players);
		void addScore(const QString &nick, const QStringList &words, int score);
	
		int rowCount(const QModelIndex &index) const;
		int columnCount(const QModelIndex &index) const;
		QVariant data(const QModelIndex &index, int role) const;
		QVariant headerData(int section, Qt::Orientation orientation, int role) const;
		
	private:
		void clean();

		QList< QPair<QString, QList< logEntry*> > > m_scores;
};

#endif
