/***************************************************************************
 *   Copyright (C) 2007 by Albert Astals Cid <tsdgeos@terra.es>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef MESSAGESERVER_H
#define MESSAGESERVER_H

#include "messagehandler.h"

class QTcpServer;

class messageClient : public QObject
{
Q_OBJECT
	public:
		messageClient();
	
	private slots:
		void processNewMessage(const message &m);
		void slotSocketConnected();
	
	private:
		QTcpSocket *m_clientSocket;
		messageHandler m_messageHandler;
};

class messageServer : public QObject
{
Q_OBJECT
	public:
		messageServer();
	
	private slots:
		void slotReadyAccept();
		void processNewMessage(const message &m);
	
	private:
		QTcpServer *m_serverSocket;
		QTcpSocket *m_clientSocket;
		messageHandler m_messageHandler;
};

#endif
