/***************************************************************************
 *   Copyright (C) 2005 by Albert Astals Cid <tsdgeos@terra.es>            *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef TILEFACTORY_H
#define TILEFACTORY_H

#include <QPair>
#include <QList>
#include <kombination_export.h>
#include "replacementshandler.h"

class QDomNode;

class tile;

class KOMBINATION_EXPORT tileFactory
{
	public:
		tileFactory();

		static bool haveTilesFor(const QString &langcode);

		bool readTileSet(const QString &langcode);
		
		QList<tile> tiles() const;
		QList< QPair<QString, int> > tileStringList() const;
		QStringList exclusiveTileList() const;
		replacementsHandler getReplacementsHandler() const;

		static QString simpleXMLSerialization(const tile *t);
		static tile* simpleXMLDeserialization(const QString &s);

	private:
		void readTiles(const QDomNode &n);
		void readReplacements(const QDomNode &n);
		void readExclusiveTiles(const QDomNode &n);
		
		QList<tile> m_tiles;
		QList< QPair<QString, int> > m_tileList;
		QStringList m_exclusiveTileList;
		replacementsHandler m_replacements;
};

#endif
