/***************************************************************************
 *   Copyright (C) 2005 by Albert Astals Cid <tsdgeos@terra.es>            *
 *   Copyright (C) 2005 by Pino Toscano      <toscano.pino@tiscali.it>     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef UTILS_H
#define UTILS_H

#include <QPoint>
#include <QMimeData>

class QDrag;
class QWidget;
class tile;
class QPixmap;

namespace Utils
{
	class sMimeData : public QMimeData
	{
		Q_OBJECT
		public:
			QObject* senderItem() const { return item; }
			void setSenderItem(QObject * senderItem) { item = senderItem; }
		private:
			QObject * item;
	};
	bool checkRange(int value, int min, int max);

	bool isValidPoint(const QPoint &p);
	bool isValidPoint(int x, int y);

	QPoint calcMousePositionPoint(const QPoint &p, double width);
	int calcMousePositionInt(int pos, double width);

	QDrag* createDragForTile(QWidget *dragparent, QObject *sender, const QPixmap &pixmap, tile *t, double size);
}

#endif
