/**************************************************************************
*   Copyright (C) 2005 by Lukas Tinkl                                     *
*   lukas@kde.org                                                         *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
***************************************************************************/

#ifndef _DLGNEWSERVER_H_
#define _DLGNEWSERVER_H_

#include <kdialogbase.h>

class GameManager;
class GameComboBox;
class QLineEdit;

/**
 * Dialog for adding new servers to the Favorites
 *
 * @short New server dialog
 */
class NewServerDlg: public KDialogBase
{
    Q_OBJECT
public:
    /**
     * CTOR
     */
    NewServerDlg( GameManager * manager, QWidget * parent, const char * name );

    /**
     * @return the selected address (IP:port)
     * @see Server::address
     */
    QString address() const;

    /**
     * @return the ID of the game
     * @see Server::gameID
     */
    QString gameID() const;

    /**
     * Set the game ID
     * @see Server::setGameID
     */
    void setGameID( const QString & gameID );

private:
    QLineEdit * m_addressLined;
    GameComboBox * m_gameCombo;
};

#endif
