/**************************************************************************
*   Copyright (C) 2005 by Lukas Tinkl <lukas@kde.org>                     *
*   Copyright (C) 1998-2000 Roman Pozlevich <roma@botik.ru>               *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
***************************************************************************/

#ifndef _GAMETYPES_H_
#define _GAMETYPES_H_

#include <string.h>

#define MAX_Q3A_TYPES 9
static char *q3a_gametypes[MAX_Q3A_TYPES] =
{
    "FFA",                /* 0 = Free for All */
    "1v1",                /* 1 = Tournament */
    NULL,                 /* 2 = Single Player */
    "TDM",                /* 3 = Team Deathmatch */
    "CTF",                /* 4 = Capture the Flag */
    "1FCTF",              /* 5 = One Flag Capture the Flag */
    "OVR",                /* 6 = Overload */
    "HRV",                /* 7 = Harvester */
    " mod "               /* 8+ is usually a client-side mod */
};

#define MAX_Q3A_OSP_TYPES 7
static char *q3a_osp_gametypes[MAX_Q3A_OSP_TYPES] =
{
    "FFA",                /* 0 = Free for All */
    "1v1",                /* 1 = Tournament */
    "FFA Comp",           /* 2 = FFA, Competition */
    "TDM",                /* 3 = Team Deathmatch */
    "CTF",                /* 4 = Capture the Flag */
    "Clan Arena",         /* 5 = Clan Arena */
    "Custom OSP"          /* 6+ is usually a custom OSP setting */
};

#define MAX_Q3A_UT2_TYPES 9
static char *q3a_ut2_gametypes[MAX_Q3A_UT2_TYPES] =
{
    "FFA",                /* 0 = Free for All */
    "FFA",                /* 1 = Free for All */
    "FFA",                /* 2 = Free for All */
    "TDM",                /* 3 = Team Deathmatch */
    "Team Survivor",      /* 4 = Team Survivor */
    "Follow the Leader",  /* 5 = Follow the Leader */
    "Capture & Hold",     /* 6 = Capture & Hold */
    "CTF",                /* 7 = Capture the Flag */
    NULL                  /* 8+ ?? */
};

#define MAX_Q3A_UT3_TYPES 9
static char *q3a_ut3_gametypes[MAX_Q3A_UT3_TYPES] =
{
    "FFA",                /* 0 = Free for All */
    "FFA",                /* 1 = Free for All */
    "FFA",                /* 2 = Free for All */
    "TDM",                /* 3 = Team Deathmatch */
    "Team Survivor",      /* 4 = Team Survivor */
    "Follow the Leader",  /* 5 = Follow the Leader */
    "Capture & Hold",     /* 6 = Capture & Hold */
    "CTF",                /* 7 = Capture the Flag */
    "Bomb Mode"           /* 8 = Bomb Mode */
};

#define MAX_Q3A_Q3TC045_TYPES 11
static char *q3a_q3tc045_gametypes[MAX_Q3A_Q3TC045_TYPES] =
{
    "FFA",                /* 0 = Free for All */
    NULL,                 /* 1 = ? */
    NULL,                 /* 2 = ? */
    "Survivor",           /* 3 = Survivor */
    "TDM",                /* 4 = Team Deathmatch */
    "CTF",                /* 5 = Capture the Flag */
    "Team Survivor",      /* 6 = Team Survivor */
    NULL,                 /* 7 = ? */
    "Capture & Hold",     /* 8 = Capture & Hold */
    "King Of The Hill",   /* 9 = King of the hill */
    NULL                  /* 10+ ?? */
};

#define MAX_Q3A_TRUECOMBAT_TYPES 8
static char *q3a_truecombat_gametypes[MAX_Q3A_TRUECOMBAT_TYPES] = {
    "FFA",                /* 0 = Free for All */
    "Survivor",           /* 1 = Survivor/Last Man Standing */
    NULL,                 /* 2 = ? */
    "TDM",                /* 3 = Team Deathmatch */
    "Reverse CTF",        /* 4 = Reverse CTF */
    "CTF",                /* 5 = Capture the Flag */
    "Team Survivor",      /* 6 = Team Survivor */
    "Mission"             /* 7 = Mission */
};

#define MAX_Q3A_THREEWAVE_TYPES 12
static char *q3a_threewave_gametypes[MAX_Q3A_THREEWAVE_TYPES] =
{
    "FFA",                /* 0  - Free For All */
    "1v1",                /* 1  - Tournament */
    NULL,                 /* 2  - Single Player (invalid, don't use this) */
    "TDM",                /* 3  - Team Deathmatch */
    "ThreeWave CTF",      /* 4  - ThreeWave CTF */
    "One flag CTF",       /* 5  - One flag CTF  (invalid, don't use this) */
    "Obelisk",            /* 6  - Obelisk       (invalid, don't use this) */
    "Harvester",          /* 7  - Harvester     (invalid, don't use this) */
    "Portal",             /* 8  - Portal        (invalid, don't use this) */
    "CaptureStrike",      /* 9  - CaptureStrike */
    "Classic CTF",        /* 10 - Classic CTF */
    NULL                  /* 11+ ??? */
};

#define MAX_Q3A_TRIBALCTF_TYPES 10
static char *q3a_tribalctf_gametypes[MAX_Q3A_TRIBALCTF_TYPES] =
{
    NULL,                 /* 0 - Unknown */
    NULL,                 /* 1 - Unknown */
    NULL,                 /* 2 - Unknown */
    NULL,                 /* 3 - Unknown */
    NULL,                 /* 4 - Unknown */
    NULL,                 /* 5 - Unknown */
    "Freestyle",          /* 6 - Freestyle */
    "Fixed",              /* 7 - Fixed */
    "Roulette",           /* 8 - Roulette */
    NULL                  /* 9+ ??? */
};

#define MAX_Q3A_SEALS_TYPES 5
static char *q3a_seals_gametypes[MAX_Q3A_SEALS_TYPES] =
{
    NULL,                 /* 0 = devmode */
    NULL,                 /* 1 = invalid */
    NULL,                 /* 2 = invalid */
    "Operations",         /* 3 = Team Deathmatch */
    NULL                  /* 4+ invalid */
};

#define MAX_Q3A_AFTERWARDS_TYPES 3
static char *q3a_afterwards_gametypes[MAX_Q3A_AFTERWARDS_TYPES] =
{
    "Tactical",           /* 0 = Tactical */
    "FFA",                /* 1 = Deatchmatch */
    NULL                  /* 2+ ?? */
};

#define MAX_Q3A_ARENA_TYPES 9
/* Not sure what the proper types are, but 99% of them are a game */
/* type of 8.  Just call them all "arena" */
static char *q3a_arena_gametypes[MAX_Q3A_ARENA_TYPES] =
{
    "arena",              /* 0 = Arena */
    "arena",              /* 1 = Arena */
    "arena",              /* 2 = Arena */
    "arena",              /* 3 = Arena */
    "arena",              /* 4 = Arena */
    "arena",              /* 5 = Arena */
    "arena",              /* 6 = Arena */
    "arena",              /* 7 = Arena */
    "arena"               /* 8 = Arena */
};

#define MAX_Q3A_CPMA_TYPES 6
static char *q3a_cpma_gametypes[MAX_Q3A_CPMA_TYPES] =
{
    "FFA",                /* 0 = Free for All */
    "1v1",                /* 1 = Tournament */
    NULL,                 /* 2 = Single Player */
    "TDM",                /* 3 = Team Deathmatch */
    "CTF",                /* 4 = Capture the Flag */
    "Clan Arena"          /* 5 = Clan Arena */
};

#define MAX_Q3A_Q3F_TYPES 6
static char *q3a_q3f_gametypes[MAX_Q3A_Q3F_TYPES] =
{
    "q3f",                /* 0 = Arena */
    "q3f",                /* 1 = Arena */
    "q3f",                /* 2 = Arena */
    "q3f",                /* 3 = Arena */
    "q3f",                /* 4 = Arena */
    "q3f"                 /* 5 = Arena */
};

#define MAX_Q3A_WQ3_TYPES 6
static char *q3a_wq3_gametypes[MAX_Q3A_WQ3_TYPES] =
{
    "FFA",
    "Duel",
    NULL,
    "TDM",
    "Round Teamplay",
    "Bank Robbery"
};

#define MAX_Q3A_WOP_TYPES 9
static char *q3a_wop_gametypes[MAX_Q3A_WOP_TYPES] =
{
    NULL,
    NULL,
    NULL,
    "Spray your Color FFA (SyC)", /* 3 */
    "LastPadStanding (LPS)", /* 4 */
    NULL,
    NULL,
    "Spray your Color Teamgame (SyC)", /* 7 */
    "BigBalloon (BB)" /* 8 */
};

#define MAX_WOLF_TYPES 9
static char *wolf_gametypes[MAX_WOLF_TYPES] =
{
    NULL,                 /* 0 - Unknown */
    NULL,                 /* 1 - Unknown */
    NULL,                 /* 2 - Unknown */
    NULL,                 /* 3 - Unknown */
    NULL,                 /* 4 - Unknown */
    "WolfMP",             /* 5 - standard objective mode */
    "WolfSW",             /* 6 - Stopwatch mode */
    "WolfCP",             /* 7 - Checkpoint mode */
    NULL                  /* 8+ ??? */
};

#define MAX_WOLFET_TYPES 7
static char *wolfet_gametypes[MAX_WOLFET_TYPES] =
{
    NULL,                 /* 0 - Unknown */
    NULL,                 /* 1 - Unknown */
    "Obj",                /* 2 - Single-Map Objective */
    "SW",                 /* 3 - Stopwatch */
    "Cmpgn",              /* 4 - Campaign */
    "LMS",                /* 5 - Last Man Standing */
    NULL                  /* 6+ ??? */
};

#define MAX_JK3_TYPES 9
static char *jk3_gametypes[MAX_JK3_TYPES] =
{
    "FFA",                /* 0 - Free For All */
    NULL,                 /* 1 - Unknown */
    NULL,                 /* 2 - Unknown */
    "Duell",              /* 3 - Duell */
    "PDuell",             /* 4 - Power Duell */
    NULL,                 /* 5 - Unknown */
    "TFFA",               /* 6 - Team Free For All */
    "Siege",              /* 7 - Siege */
    "CTF"                 /* 8 - Capture the Flag */
};

struct q3a_gametype_s
{
    char* mod;
    char** gametypes;
    int number;
};

struct q3a_gametype_s q3a_gametype_map[] =
{
    {
        "baseq3",
        q3a_gametypes,
        MAX_Q3A_TYPES
    },
    {
        "osp",
        q3a_osp_gametypes,
        MAX_Q3A_OSP_TYPES
    },
    {
        "q3ut2",
        q3a_ut2_gametypes,
        MAX_Q3A_UT2_TYPES
    },
    {
        "q3ut3",
        q3a_ut3_gametypes,
        MAX_Q3A_UT3_TYPES
    },
    {
        "threewave",
        q3a_threewave_gametypes,
        MAX_Q3A_THREEWAVE_TYPES
    },
    {
        "seals",
        q3a_seals_gametypes,
        MAX_Q3A_SEALS_TYPES
    },
    {
        "TribalCTF",
        q3a_tribalctf_gametypes,
        MAX_Q3A_TRIBALCTF_TYPES
    },
    {
        "missionpack",
        q3a_gametypes,
        MAX_Q3A_TYPES
    },
    {
        "generations",
        q3a_gametypes,
        MAX_Q3A_TYPES
    },
    {
        "truecombat",
        q3a_truecombat_gametypes,
        MAX_Q3A_TRUECOMBAT_TYPES
    },
    {
        "q3tc045",
        q3a_q3tc045_gametypes,
        MAX_Q3A_Q3TC045_TYPES
    },
    {
        "freeze",
        q3a_gametypes,
        MAX_Q3A_TYPES
    },
    {
        "afterwards",
        q3a_afterwards_gametypes,
        MAX_Q3A_AFTERWARDS_TYPES
    },
    {
        "cpma",
        q3a_cpma_gametypes,
        MAX_Q3A_CPMA_TYPES
    },
    {
        "arena",
        q3a_arena_gametypes,
        MAX_Q3A_ARENA_TYPES
    },
    {
        "instaunlagged",
        q3a_gametypes,
        MAX_Q3A_TYPES
    },
    {
        "instagibplus",
        q3a_gametypes,
        MAX_Q3A_TYPES
    },
    {
        "beryllium",
        q3a_gametypes,
        MAX_Q3A_TYPES
    },
    {
        "excessive",
        q3a_gametypes,
        MAX_Q3A_TYPES
    },
    {
        "q3f",
        q3a_q3f_gametypes,
        MAX_Q3A_Q3F_TYPES
    },
    {
        "q3f2",
        q3a_q3f_gametypes,
        MAX_Q3A_Q3F_TYPES
    },
    {
        "westernq3",
        q3a_wq3_gametypes,
        MAX_Q3A_WQ3_TYPES
    },
    {
        "wop",
        q3a_wop_gametypes,
        MAX_Q3A_WOP_TYPES
    },
    {
        NULL,
        NULL,
        0
    }
};

struct q3a_gametype_s wolf_gametype_map[] =
{
    {
        "main",
        wolf_gametypes,
        MAX_WOLF_TYPES
    },
    {
        "wolfmp",
        wolf_gametypes,
        MAX_WOLF_TYPES
    },
    {
        "bani",
        wolf_gametypes, /* exports additional gametypes via g_gametype2 */
        MAX_WOLF_TYPES
    },
    {
        "headshot",
        wolf_gametypes,
        MAX_WOLF_TYPES
    },
    {
        "osp",
        wolf_gametypes,
        MAX_WOLF_TYPES
    },
    {
        "shrubmod",
        wolf_gametypes,
        MAX_WOLF_TYPES
    }
};

/* didn't find docu about this, so use q3a types */
struct q3a_gametype_s ef_gametype_map[] =
{
    {
        "baseEF",
        q3a_gametypes,
        MAX_Q3A_TYPES
    }
};

struct q3a_gametype_s wolfet_gametype_map[] =
{
    {
        "et",
        wolfet_gametypes,
        MAX_WOLFET_TYPES
    },
    {
        "etmain",
        wolfet_gametypes,
        MAX_WOLFET_TYPES
    },
    {
        "ettest",
        wolfet_gametypes,
        MAX_WOLFET_TYPES
    },
    {
        "etpro",
        wolfet_gametypes,
        MAX_WOLFET_TYPES
    },
    {
        "shrubet",
        wolfet_gametypes,
        MAX_WOLFET_TYPES
    },
    {
        "bobots",
        wolfet_gametypes,
        MAX_WOLFET_TYPES
    },
    {
        "etpub",
        wolfet_gametypes,
        MAX_WOLFET_TYPES
    }
};

struct q3a_gametype_s jk3_gametype_map[] =
{
    {
        "basejka",
        jk3_gametypes,
        MAX_JK3_TYPES
    },
    {
        "base",
        jk3_gametypes,
        MAX_JK3_TYPES
    },
    {
        "japlus",
        jk3_gametypes,
        MAX_JK3_TYPES
    }
};

#endif
