// -*- coding: utf-8 -*-
/***************************************************************************
*   Copyright (C) 2005 by Lukas Tinkl                                     *
*   lukas@kde.org                                                         *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
***************************************************************************/


#include "kqf.h"

#include <kapplication.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>

static const char description[] = I18N_NOOP( "An online game server browser" );

static const char version[] = "0.1";

static KCmdLineOptions options[] =
    {
        { "+[URL]", I18N_NOOP( "Document to open" ), 0 },
        KCmdLineLastOption
    };

int main( int argc, char **argv )
{
    KAboutData about( "kqf", I18N_NOOP( "kqf" ), version, description,
                      KAboutData::License_GPL, "(C) 2005 Lukáš Tinkl", 0,
                      "http://developer.kde.org/~lukas/kqf/" );
    about.addAuthor( "Lukáš Tinkl", I18N_NOOP( "Author and maintainer" ), "lukas@kde.org" );
    KCmdLineArgs::init( argc, argv, &about );
    KCmdLineArgs::addCmdLineOptions( options );
    KApplication app;

    // see if we are starting with session management
    if ( app.isRestored() )
    {
        RESTORE( kqf );
    }
    else
    {
        // no session.. just start up normally
        KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
        if ( args->count() == 0 )
        {
            kqf * widget = new kqf;
            widget->show();
        }
        else
        {
            int i = 0;
            for ( ; i < args->count(); i++ )
            {
                kqf *widget = new kqf;
                widget->show();
            }
        }
        args->clear();
    }

    return app.exec();
}
