/****************************************************************
Copyright 2008  Parker Coates parker.coates@gmail.com

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) version 3, or any
later version accepted by the membership of KDE e.V. (or its
successor approved by the membership of KDE e.V.), which shall
act as a proxy defined in Section 6 of version 3 of the license.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library.  If not, see <http://www.gnu.org/licenses/>.
****************************************************************/

#ifndef KSCORETABLE_H
#define KSCORETABLE_H

#include "kscoreboardbase.h"

#include <QtGui/QWidget>

class KDEGAMES_EXPORT KScoreTable : public QWidget, public KScoreBoardBase
{
        Q_OBJECT
    public:
        KScoreTable(const QString& groupKey, QWidget * parent = 0);
        virtual ~KScoreTable();

        void setGroup(const QString& groupKey);
        QString group() const;
        void setDisplayOptions(const KScoreBoardBase::DisplayOptions & options);

    public Q_SLOTS:
        void acceptName();
        void cancelNameRequest();

    protected:
        virtual void keyPressEvent(QKeyEvent * e);

    private:
        class KScoreTablePrivate;
        KScoreTablePrivate * const d;

        Q_PRIVATE_SLOT(d, void newScore(const QString& groupKey, int rank))
};

#endif
