/*
Copyright (c) 2006, 2007, Nicolas Roffet, <nicolas-kde@roffet.com>

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU Library General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
*/

#ifndef KSIMILIDECKOFCARDS_H
#define KSIMILIDECKOFCARDS_H



#include <QObject>
#include <QList>
class QWidget;


#include <KRandomSequence>



/**
 * @brief The deck of cards gathers all the cards, that are not displayed on the board.
 *
 * Cards that are randomly selected to be displayed on the board come from the deck.
 * Cards that are removed from the board are added to the deck back.
 */
class KSimiliDeckOfCards : public QObject
{
	Q_OBJECT

	public:
		KSimiliDeckOfCards(QWidget *parent);

		int takeNewCard();
		void removeCardFromBoard(const int cardId);


	private:
		QList<int> m_deckCards;
		QList<int> m_boardCards;

		KRandomSequence m_random;
};

#endif //KSIMILIDECKOFCARDS_H
