/*
Copyright (c) 2006, 2007, Nicolas Roffet, <nicolas-kde@roffet.com>

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU Library General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA
*/

#ifndef KSIMILILASTCOMBINATIONWIDGET_H
#define KSIMILILASTCOMBINATIONWIDGET_H


#include <QFrame>
class QLabel;
class QString;
class QWidget;


class KSimiliCard;



/**
 * @brief Widget that displays the last combination and analyze it.
 *
 */
class KSimiliLastCombinationWidget : public QFrame
{
	Q_OBJECT

	public:
		KSimiliLastCombinationWidget(QWidget *parent);

	public slots:
		void selectionOf3Cards(QList <KSimiliCard *> cards);

	private:
		QLabel *m_labelColor;
		QLabel *m_labelForm;
		QLabel *m_labelFilling;
		QLabel *m_labelNumber;
		QLabel *m_labelResultColor;
		QLabel *m_labelResultForm;
		QLabel *m_labelResultFilling;
		QLabel *m_labelResultNumber;

		KSimiliCard *m_cards[3];
};


#endif //KSIMILILASTCOMBINATIONWIDGET_H
