#ifndef KTANKITEM_H
#define KTANKITEM_H
#include <KGLItem>
#include <KGLSpriteItem>
#include <KGLRectItem>
#include <KGLContainerItem>
#include <Eigen/Geometry>

class KTankItem : public  KGLContainerItem
{
public:
KTankItem(QString path);

void setMouse(QPointF mouse=QPointF(0,0));
void moveUp();
void moveDown();
void rotateLeft();
void rotateRight();
float turretAngle(){return m_turretAngle;}
QPointF turretDirection(){return turretItem->direction();}
QPointF center() {return carItem->center();}
QPointF transformCenter() const {return carItem->transformCenter();}
QRectF transformBoundingRect() const  {return carItem->transformBoundingRect();}
virtual QPolygonF transformPolygon()const{return carItem->transformPolygon();}

void collidingWith(KGLItemBase* item);
KGLSpriteItem * theCar(){return carItem;}
protected:
void rotateDirection(float a);

private:
KGLSpriteItem * carItem;
KGLSpriteItem * turretItem;
float m_turretAngle;
float m_speedRotation;
float m_speed;
bool stop;
QPolygonF wall;


};
#endif