/* -*- coding: utf-8 -*- */
/* This file is part of Ktank.
   Created by sacha schutz and olivier gueudelot

   KTank is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation, version 2.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA
*/
#ifndef KT_BLOCKITEM_H
#define KT_BLOCKITEM_H


#include <QPainter>
#include <QPointF>
#include <QPixmap>
#include <QGraphicsPixmapItem>
#include <QKeyEvent>
#include <QSize>
#include <QMap>
#include <QString>
#include <QDebug>
#include <QStyleOption>
#include <QObject>


enum corner {CUL,CUR,CDL,CDR,HU,HD,VL,VR,NO};



class KTBlockItem;
class KTBlockItem : public QGraphicsRectItem
{

public:
KTBlockItem( QGraphicsItem * parent = 0);

KTBlockItem(const KTBlockItem &original);  //Constructeur de copy

void paint ( QPainter * painter, const QStyleOptionGraphicsItem * option, QWidget * widget = 0 ) ;
void drawGrapper(QPainter * painter, const QStyleOptionGraphicsItem * option);
corner getCorner( QPointF mouse);
void mouseMoveEvent ( QGraphicsSceneMouseEvent * event );
void hoverMoveEvent ( QGraphicsSceneHoverEvent * event );
void contextMenuEvent(QGraphicsSceneContextMenuEvent *event);
void setName(QString n){name =n;}
QPixmap  pixmap (){return pix;}
void setPixmap(QPixmap p){pix = p ;}


static QPixmap copyPix(QPixmap original, int rx=1, int ry=1);

void setRepeatTex(QPoint r){repeatTex = r;}
QPoint getRepeatTex(){return repeatTex;}

QString getName(){return name;}


void setTexturePath(QString name){vTexturePath=name;}
QString texturePath(){return vTexturePath;}

void setBehavior(QString b){vBehavior=b;}
QString behavior(){return vBehavior;}

void arrondirRect( int fac);

static int arr( double value, int fac);
static QRectF arrondirRect( QRectF rect, int fac);


bool textureChanged;


private:

bool grabbed;
corner grab;
QString name;
QPixmap pix;
QPixmap *temp;
QPoint repeatTex;
QString vTexturePath;
QString vBehavior;

};

#endif

