/* This file is part of Ktank.
   Created by sacha schutz and olivier gueudelot

   KTank is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation, version 2.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA
*/
#ifndef KT_MAIN_EDITOR
#define KT_MAIN_EDITOR


#include <KXmlGuiWindow>
#include <KTextEdit>
#include <KListWidget>
#include <QPushButton>
#include <KStandardAction>
#include <KAction>
#include <KActionCollection>


#include "ktmapview.h"
#include "ktmapscene.h"
#include "ktblockitem.h"
#include "ktitemselector.h"
#include "ktitemproperty.h"
#include "ktitemlist.h"
#include "ktmapfile.h"

class KTMainEditor : public  KXmlGuiWindow
{
Q_OBJECT
public:
KTMainEditor(QWidget * parent = 0);
void setupActions();


public slots:
void saveMap();
void openMap();
void openMap(const QString &inputFileName);


private:
KTextEdit * textArea;
KTMapView * view;
KTMapScene* scene;
KTItemProperty * itemProperty;
 KTItemList * itemsList;

QPushButton * b;
};

#endif


