#include "ktmapfile.h"

#include <QMessageBox>
KTMapFile::KTMapFile(QObject * parent) :QObject(parent)
{




}

//====================================================
bool KTMapFile::createFile(KUrl url, KTMapScene * scene)
{

    file = new QFile;
    ktankmap = doc.createElement("ktmap");
    ktankmap.setAttribute("name",url.fileName() ); 
    doc.appendChild(ktankmap);
    file->setFileName(url.path());


    if (!file->open(QIODevice::WriteOnly))
        return false;
    out.setDevice(file);



QGraphicsItem * item ;

foreach ( item, scene->items())
{
KTBlockItem * b = dynamic_cast <KTBlockItem*>(item);
addBlock (b);

}

 

    QDomNode noeud = doc.createProcessingInstruction("xml","version=\"1.0\"");
    doc.insertBefore(noeud,doc.firstChild());

    doc.save(out,2);
    file->close();

    return true;

}
//=====================================================
  bool KTMapFile:: openFile(KUrl url, KTMapScene *scene)
{

QFile file(url.path());
if (!file.open(QIODevice::ReadOnly))
     return false;

if (!doc.setContent(&file)) {        //établit le document XML à
     file.close();                   //partir des données du fichier (hiérarchie, etc)
     return false;
}
file.close();

return true;



}
//====================================================
 void KTMapFile::readDoc(KTMapScene *scene)
{
int i=0;
QString affichage;

QDomNodeList tab;

QDomElement block;
QDomNode n;
QMessageBox a(0);

double x,y,w,h;
int rx,ry;
QString texture;
QString name;





QDomElement racine = doc.documentElement();            //renvoie la balise racine
QDomNode noeud = racine.firstChild();          //renvoie la 1ère balise « mesure »
while(!noeud.isNull())
{
    //convertit le nœud en élément pour utiliser les
    //méthodes tagName() et attribute()
    block = noeud.toElement();
    //vérifie la présence de la balise « mesure »
    if (block.tagName() == "block")
    {
    
  x = block.attribute("x").toDouble();
  y = block.attribute("y").toDouble();
  w = block.attribute("width").toDouble();
  h = block.attribute("height").toDouble();
  rx= block.attribute("rx").toInt();
  ry= block.attribute("ry").toInt();
   
        tab = block.childNodes();       //crée un tableau des enfants de « mesure »
        
// for(i=0;i<tab.length();i++)
//         {

            //pour chaque enfant, on extrait la donnée et on concatène
            n = tab.item(0);
            name= n.firstChild().toText().data();
	    n = tab.item(1);
	    texture=n.firstChild().toText().data();
/*
        }*/


KTBlockItem * item = new KTBlockItem;

if ( texture != "no_texture")
{
QPixmap * pix = new QPixmap(texture);
item->setTexturePath(texture);
item->setRepeatTex(QPoint(rx,ry));
item->setPixmap(item->copyPix(*pix,rx,ry));
}

item->setRect(x,y,w,h);
item->setToolTip(name);


scene->addItem(item);




    }
    noeud = noeud.nextSibling();         //passe à la “mesure” suivante
  }
}









//====================================================
bool KTMapFile::addBlock(KTBlockItem * b)
{
    QDomElement bloc= doc.createElement("block");
   ktankmap.appendChild(bloc);
    bloc.setAttribute("x",b->rect().x()+b->pos().x()); 
    bloc.setAttribute("y",b->rect().y()+b->pos().y()); 
    bloc.setAttribute("width",b->rect().width()); 
    bloc.setAttribute("height",b->rect().height()); 
    bloc.setAttribute("rx",b->getRepeatTex().x()); 
    bloc.setAttribute("ry",b->getRepeatTex().y()); 

    QDomElement name= doc.createElement("name");
    bloc.appendChild(name);

    QDomElement texture= doc.createElement("texture");
    bloc.appendChild(texture);


name.appendChild( doc.createTextNode(b->toolTip()));
texture.appendChild( doc.createTextNode(b->texturePath()));


    return true;
}

//====================================================


