/* -*- coding: utf-8 -*- */
/* This file is part of Ktank.
   Created by sacha schutz and olivier gueudelot

   KTank is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation, version 2.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA
*/
#include "ktmapscene.h"

using namespace std;

KTMapScene::KTMapScene(int w, int h, QObject *parent): QGraphicsScene(parent)
{

widthGrid  =640;
heightGrid =480;
levelGrid  = 4;
isDrawingRect = false;
isGrid        = true;


/*
     QLinearGradient linearGrad(QPointF(0, 0), QPointF(0, 500));
     linearGrad.setColorAt(0, Qt::gray);
     linearGrad.setColorAt(1, Qt::white);*/

setBackgroundBrush (QBrush(Qt::lightGray));
 
setSceneRect (0, 0,640,480);



}

//====================================================
void KTMapScene::drawForeground ( QPainter * painter, const QRectF & rect )
{
QGraphicsScene::drawForeground(painter,rect);

if ( isGrid == true)
drawGrid(painter);
}



//====================================================
void KTMapScene::drawGrid( QPainter * painter)
{



//grid
int palw = width()/levelGrid;
int palh = width()/levelGrid;

painter->setPen(QPen(Qt::gray));
for  (int w=0; w <= width(); w+=palw)
{
painter->drawLine(w,0,w,height());
}


//painter->setPen(QPen(Qt::gray, 1));
for  (int h=0; h <= height(); h+=palh)
{
painter->drawLine(0,h,width(),h);

}


painter->setPen(Qt::red);
painter->drawLine(0,0,20,0);
painter->setPen(Qt::green);
painter->drawLine(0,0,0,20);


}

//=============================================================
void KTMapScene::uperGrid()
{
if (levelGrid < 64)
levelGrid=levelGrid*2;
update();
}
//============================================================

void KTMapScene::downGrid()
{
if (levelGrid > 1 )
levelGrid= levelGrid/2;
update();
}
//============================================================
void KTMapScene::mousePressEvent ( QGraphicsSceneMouseEvent * mouseEvent )
{
QGraphicsScene::mousePressEvent(mouseEvent);

if ( mouseEvent->button()==Qt::RightButton)
addNewBloc();

if ( selectedItems().size()>0)
{
emit selected(dynamic_cast<KTBlockItem*>(selectedItems().at(0)));
}


emit refresh();


}
//==============================================================
void KTMapScene::mouseMoveEvent ( QGraphicsSceneMouseEvent * mouseEvent)
{
QGraphicsScene::mouseMoveEvent  (mouseEvent);

}
//============================================================

void KTMapScene::mouseReleaseEvent ( QGraphicsSceneMouseEvent * mouseEvent )
{
QGraphicsScene::mouseReleaseEvent  (mouseEvent);




}
//====================================================================

void KTMapScene::remItem (KTBlockItem * item)
{
  
;

}
//====================================================================
void KTMapScene::removeItemSelected()
{

QGraphicsItem* i;

foreach (i,selectedItems())
removeItem(i);


}

//====================================================================
void KTMapScene::copyItems()
{

  copy_items.clear();
  
  for ( int i=0; i<selectedItems().size(); ++i)
  {
  copy_items.append(dynamic_cast <KTBlockItem*>(selectedItems().at(i)));
  
  }
  

  
}

//=======================================================================


void KTMapScene::pasteItems()
{
   KTBlockItem * n = new KTBlockItem;

  if ( copy_items.size() >0)
  {
    
   for ( int i=0; i< copy_items.size(); ++i)
   {// A mettre dans un constructeur de copy!!!!!!!!!
 KTBlockItem * n = new KTBlockItem;
 n->setRect( copy_items.at(i)->rect());
 n->setPos(copy_items.at(i)->pos());
 n->setRepeatTex(copy_items.at(i)->getRepeatTex());
 n->setPixmap(copy_items.at(i)->pixmap());
  addItem(n);
 n->setToolTip (QString("box-")+QString::number(items().size()));

   }
     
    
    
  }
  

  
}

//====================================================================
int KTMapScene::arrondir ( double value, int fac)
{
int val = (int)(value);

int reste  = val % fac;

if ( reste <= (int)(fac/2))
val -= reste;

if ( reste > (int)(fac/2))
val+=(fac - reste);


return val;



}

//========================================================
KTBlockItem* KTMapScene::addNewBloc()
{


KTBlockItem * bloc = new KTBlockItem;
bloc->setRect(20,20,40,40);
bloc->setToolTip (QString("box-")+QString::number(items().size()));
addItem(bloc);



return bloc;
}

//============================================================
void KTMapScene::hideItems()
{

// QGraphicsItem* i;
// 
// foreach (i,selectedItems())
// {
// if ( i->isVisible()) i->setVisible(false);
// else i->setVisible(true);
// 
// }
// 





}

// void KTMapScene::keyPressEvent( QKeyEvent * keyEvent )
// {
//  
// 
// }
// //====================================================
// void KTMapScene::keyReleaseEvent( QKeyEvent * keyEvent )
// {
// 
// }
// 
// 
// //====================================================
// void KTMapScene::mousePressEvent(QGraphicsSceneMouseEvent * mouseEvent )
// {
// 
// }
// //====================================================
//  void KTMapScene::mouseMoveEvent ( QGraphicsSceneMouseEvent * mouseEvent ) 
// {
//  
// }
// 
// //====================================================

