/* -*- coding: utf-8 -*- */
/* This file is part of Ktank.
   Created by sacha schutz and olivier gueudelot

   KTank is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation, version 2.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
   02110-1301, USA
*/
#ifndef KT_MAPEDITOR_H
#define KT_MAPEDITOR_H

#include <QGraphicsScene>
#include <QGraphicsSceneMouseEvent>
#include <QPainter>
#include <QPointF>
#include <QPixmap>
#include <QGraphicsPixmapItem>
#include <QKeyEvent>
#include <QSize>
#include <QMap>
#include <QList>
#include <QMapIterator>
#include <QDebug>
#include <QModelIndex>
#include <KListWidget>

#include <KStandardAction>

#include "ktconstants.h"
#include "ktblockitem.h"
//#include "ktgrounditem.h"


/**
* Classe KT_MapEditor
* C'est l'objet qui gère toute la phase d'édition d'une map.Il sert
* d'intermédiaire entre l'interface QT et toutes les objets qui entrent
* en jeux dans l'édition d'une map, afin d'assurer une bonne coordination.
*
* @see KT_MapItem
* @see KT_Map
* @see KT_UndoRedo
*/
class KTMapScene : public QGraphicsScene
{
Q_OBJECT
public:
KTMapScene(int w, int h, QObject * parent=0);

int arrondir ( double value, int fac);



private:

     void drawForeground (QPainter * painter, const QRectF & rect );
     void drawGrid( QPainter * painter);
     void drawRectZone();

void mousePressEvent ( QGraphicsSceneMouseEvent * mouseEvent );
void mouseReleaseEvent ( QGraphicsSceneMouseEvent * mouseEvent );
void mouseMoveEvent ( QGraphicsSceneMouseEvent * mouseEvent );
// 
// 
//     // Events
//     void mousePressEvent(QGraphicsSceneMouseEvent * mouseEvent );
//     void mouseMoveEvent ( QGraphicsSceneMouseEvent * mouseEvent ) ;
//     void keyPressEvent ( QKeyEvent * keyEvent );
//     void keyReleaseEvent ( QKeyEvent * keyEvent );
// 
//     // action
//     void drawGrid();

signals:
void listChanged(QList<QGraphicsItem*> items );
void selected(KTBlockItem * item);
void refresh();

public slots:
void uperGrid() ;
void downGrid();
KTBlockItem* addNewBloc();
void remItem (KTBlockItem * item);
void removeItemSelected();
void copyItems();
void pasteItems();
void hideItems();
void showGrid(bool enabled){isGrid=enabled;update();}

private:

int widthGrid, heightGrid;
int levelGrid;
QPointF posA, posB, posM;
bool isDrawingRect;
bool isGrid;

QList<KTBlockItem*> copy_items;


};



#endif


