/***************************************************************************
 *   Copyright (C) 2003 by Albert Astals Cid                               *
 *   tsdgeos@terra.es                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#include "kcase.h"

#include <kglobal.h> // for Q_ASSERT

kcase::kcase(int x, int y)
{
	p_x = x;
	p_y = y;
	p_o = NOBODY;
	selected = false;
}

kcase::kcase(const kcase *original)
{
	p_x = original -> p_x;
	p_y = original -> p_y;
	p_o = original -> p_o;
	selected = original -> selected;
}

kcase::~kcase()
{
}

void kcase::setEmpty()
{
	p_o = NOBODY;
	selected = false;
}

void kcase::setOcupation(PLAYER o)
{
	p_o = o;
}

kcase::PLAYER kcase::getOcupation() const
{
	return p_o;
}

bool kcase::isFree() const
{
	return p_o == NOBODY;
}

kcase::PLAYER kcase::otherPlayer(PLAYER o)
{
	Q_ASSERT(o != NOBODY);
	if (o == PLAYER1) return PLAYER2;
	else return PLAYER1;
}

void kcase::toggleSelected()
{
	selected = !selected;
}
