/***************************************************************************
 *   Copyright (C) 2003 by Albert Astals Cid                               *
 *   tsdgeos@terra.es                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef KCASE_H
#define KCASE_H

class kcase
{
	public:
		kcase(int x, int y);
		kcase(const kcase *original);
		virtual ~kcase();

		// possible owners of the case
		enum PLAYER{NOBODY, PLAYER1, PLAYER2};

		// resets the case to not selected and not occupied
		virtual void setEmpty();
		
		// sets o to ocupy the case
		virtual void setOcupation(PLAYER o);
		
		// returns the ocupation
		PLAYER getOcupation() const;
		
		// returns true if the case is not occupied
		bool isFree() const;
		
		// toggles the selection of the case
		virtual void toggleSelected();
		
		// returns the inverse player of o
		static PLAYER otherPlayer(PLAYER o);

	protected:
		// the position of the case inside the board
		int p_x, p_y;
		
		// who owns the case
		PLAYER p_o;
		
		// is the case selected?
		bool selected;
};

#endif
