//Magazynier, a warehouse assistant game.
//Copyright (C) 2009 Niels Slot nielsslot@gmail.com
//
//This program is free software; you can redistribute it and/or modify
//it under the terms of the GNU General Public License as published by
//the Free Software Foundation; either version 2 of the License, or
//(at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License along
//with this program; if not, write to the Free Software Foundation, Inc.,
//51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

#ifndef ASTAR_H
#define ASTAR_H

#include <QPoint>
#include <QList>

class LevelModel;
struct PathNode;

class AStar
{
public:
	AStar();
	static QList<QPoint> *findPath(const LevelModel* levelModel, const QPoint& from, const QPoint& to);

private:
	static QList<QPoint> findAdjacentSquares(const PathNode* node, const LevelModel* levelModel);
};

#endif // ASTAR_H
