/***************************************************************************
 *   Copyright (C) 2008 Copyright 2008  Tom Vollerthun <vollerthun@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef CONFIG_H
#define CONFIG_H

#include <QString>
#include <QColor>


class Config
{
public:
    static const QString CONFIG_GROUP_COLORS;
    static const QString CONFIG_GROUP_INTELLIGENCE;
    static const QString CONFIG_GROUP_SAVEGAME;

    static const QString CONFIG_COLOR_BACKGROUND;
    static const QColor DEFAULT_COLOR_BACKGROUND;

    static const QString CONFIG_COLOR_GRID;
    static const QColor DEFAULT_COLOR_GRID;

    static const QString CONFIG_COLOR_HIGHLIGHT_GRID;
    static const QColor DEFAULT_COLOR_HIGHLIGHT_GRID;

    static const QString CONFIG_COLOR_BACKGROUND_GAMESELECT;
    static const QColor DEFAULT_COLOR_BACKGROUND_GAMESELECT;

    static const QString CONFIG_COLOR_BOX_OFFSTATE_DOT;
    static const QColor DEFAULT_COLOR_BOX_OFFSTATE_DOT;

    static const QString CONFIG_COLOR_HINT_CROSSTHROUGH;
    static const QColor DEFAULT_COLOR_HINT_CROSSTHROUGH;

    static const QString CONFIG_AUTOSELECT_CLICK_COLOR;
    static const bool DEFAULT_AUTOSELECT_CLICK_COLOR;

    static const QString CONFIG_WAIT_BEFORE_AUTOSELECT_CLICK_COLOR;
    static const int DEFAULT_WAIT_BEFORE_AUTOSELECT_CLICK_COLOR;

    static const QString CONFIG_LASTUSED_PACKAGE;
    static const QString CONFIG_LASTUSED_GAME;

};

#endif // CONFIG_H
