/***************************************************************************
 *   Copyright (C) 2008 Copyright 2008  Tom Vollerthun <vollerthun@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef IO_FACTORY_
#define IO_FACTORY_

#include <QImageReader>

#include "io/nonogram_io.h"

#include "io/xbm_format.h"
#include "io/pic_format.h"
#include "io/nog_format.h"

#include "ds/data.h"

class Io_Factory
{

    public:
        static NonogramIo * createIoForType(const QString & type);
        static Data * readFile(const QString & filename);

};
#endif /*IO_FACTORY_*/
