/***************************************************************************
 *   Copyright (C) 2008 Copyright 2008  Tom Vollerthun <vollerthun@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/

#ifndef PIC_FORMAT_H_
#define PIC_FORMAT_H_

#include "nonogram_io.h"
#include "ds/data.h"

/**
 * This class reads PIC-Files and converts them into a form the nonogram-program can use
 */

class PicFormat : public NonogramIo
{
    public:

        Data * readFile(const QString & fileName);

        Data * readData(const QByteArray & data);

    private:
        Data * picture2Data(const QVector< QVector<bool> > & picture, int rows,
                int cols, const QString & title);

        /*get the numbers for the row headings*/
        void getrows(const QVector< QVector<bool> > & picture, int rows,
                int cols, Data * data);

        /**get numbers for column headings*/
        void getcols(const QVector< QVector<bool> > & picture, int rows,
                int cols, Data * data);
};

#endif /*PIC_FORMAT_H_*/
