/***************************************************************************
 *   Copyright (C) 2008 Copyright 2008  Tom Vollerthun <vollerthun@gmx.de>
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public
 *   License as published by the Free Software Foundation; either
 *   version 2 of the License, or (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 ***************************************************************************/


#include <KApplication>
#include <KAboutData>
#include <KCmdLineArgs>
#include <KUrl>

#include "mainwindow.h"

int main(int argc, char *argv[])
{

	    KAboutData aboutData(
                         // The program name used internally.
                         "nonogram",
                         // The message catalog name
                         // If null, program name is used instead.
                         0,
                         // A displayable program name string.
                         ki18n("Nonogram"),
                         // The program version string.
                         "0.1",
                         // Short description of what the app does.
                         ki18n("A logic game"),
                         // The license this code is released under
                         KAboutData::License_GPL,
                         // Copyright Statement
                         ki18n("Copyright (c) 2008 Tom Vollerthun"),
                         // Optional text shown in the About box.
                         // Can contain any information desired.
                         ki18n("Paint by numbers"),
                         // The program homepage string.
                         "",
                         // The bug report email address
                         "vollerthun@gmx.de");

	KCmdLineArgs::init(argc, argv, &aboutData );

	KCmdLineOptions options;
	options.add("+[file]", ki18n("Document to open"));
	KCmdLineArgs::addCmdLineOptions(options);

	KApplication app;

	MainWindow* window = new MainWindow();
	window->show();

	return app.exec();
}
