/* importobject.cpp

    Parsek - free client for playing 4X space strategy games
    Copyright (C) 2006-2007  Jure Repinc <jlp@holodeck1.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "objectimport.h"

void importObject(boost::shared_ptr<Object> source, ObjectItem *target)
{
    //can break down object import into subtasks here
    setCommonProperties(source, target);
}

void setCommonProperties(boost::shared_ptr<Object> source, ObjectItem *target)
{
    switch (source->getObjectType())
    {
        case 0: target->setType(ObjectItem::Universe);
        case 1: target->setType(ObjectItem::Galaxy);
        case 2: target->setType(ObjectItem::StarSystem);
        case 3: target->setType(ObjectItem::Planet);
        case 4: target->setType(ObjectItem::Fleet);
        default: target->setType(ObjectItem::Unknown);
    }
    target->setId(source->getId());
    target->setName(QString::fromUtf8(source->getName().c_str()));
    target->setDescription(QString::fromUtf8(source->getDescription().c_str()));
    target->setModTime(source->getLastModifiedTime());
    target->setParameters(source->getParameters());
    target->setParentId(source->getParentId());
}

