/* statuswidget.cpp

    Parsek - free client for playing 4X space strategy games
    Copyright (C) 2006-2007  Jure Repinc <jlp@holodeck1.com>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/

#include "statuswidget.h"

StatusWidget::StatusWidget(QWidget *parent)
            : QWidget(parent)
{
    setupUi(this);
}
StatusWidget::~StatusWidget()
{
}
void StatusWidget::clear()
{
    serveraddressLabel->setText("Server Address: ");
    servernameLabel->setText("Server Name: ");
    serverversionLabel->setText("Server Version: ");
    clientusernameLabel->setText("Client Username: ");
    gamenameLabel->setText("Game Name: ");
    rulesetnameLabel->setText("Ruleset Name: ");
    rulesetversionLabel->setText("Ruleset Version: ");

}
void StatusWidget::setServeraddress(QString serveraddress)
{
    QString newtext = serveraddressLabel->text()
                      + "  " + serveraddress;
    serveraddressLabel->setText(newtext);
}
void StatusWidget::setServername(QString servername)
{
    QString newtext = servernameLabel->text()
                      + "  " + servername;
    servernameLabel->setText(newtext);
}
void StatusWidget::setServerversion(QString serverversion)
{
    QString newtext = serverversionLabel->text()
                      + "  " + serverversion;
    serverversionLabel->setText(newtext);
}
void StatusWidget::setClientusername(QString clientusername)
{
    QString newtext = clientusernameLabel->text()
                      + "  " + clientusername;
    clientusernameLabel->setText(newtext);
}
void StatusWidget::setGamename(QString gamename)
{
    QString newtext = gamenameLabel->text()
                      + "  " + gamename;
    gamenameLabel->setText(newtext);
}
void StatusWidget::setRulesetname(QString rulesetname)
{
    QString newtext = rulesetnameLabel->text()
                      + "  " + rulesetname;
    rulesetnameLabel->setText(newtext);
}
void StatusWidget::setRulesetversion(QString rulesetversion)
{
    QString newtext = rulesetversionLabel->text()
                      + "  " + rulesetversion;
    rulesetversionLabel->setText(newtext);
}
void StatusWidget::statusConnected()
{
    connectedLed->setColor(Qt::green);
}
void StatusWidget::statusLoggedIn()
{
    loggedLed->setColor(Qt::green);
}
void StatusWidget::statusAccountCreated()
{
    accountLed->setColor(Qt::green);
}
void StatusWidget::statusDisconnected()
{
    clear();
    connectedLed->setColor(Qt::red);
    loggedLed->setColor(Qt::red);
    accountLed->setColor(Qt::red);
}
