#ifndef TILE_H
#define TILE_H

#include <QLabel>
#include <QSvgRenderer>


class Tile : public QFrame
{
  Q_OBJECT
  public:
	Tile(int, int, QWidget *parent=0);
	virtual QChar	getValue();
	virtual void	setValue(QChar);
	virtual int		getColumn();
	virtual int		getRow();
	virtual QList<Tile *>	getNeighbours();
	virtual void 	addNeighbour(Tile*);
	virtual QList<int>	listNeighbourIDs();
	virtual void	setHighlight(bool);
	virtual bool	needsRepaint();
	bool highlight;
  
  signals:
	void clicked(QChar);


  private:
	QChar 	value;
	int		column;
	int		row;
	QList<Tile *> neighbours;
	int boardIndex(int,int);
	QSvgRenderer* renderer;

	virtual void paintEvent(QPaintEvent*);
	virtual void mouseReleaseEvent(QMouseEvent*);

	bool paintedWith;

};
 
#endif
